﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Rendering;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    public static class PortalCreator //DON'T USE!
    {
        public static GameObject[] Create(Vector2 Pos1, Vector2 Rot1, Vector2 Pos2, Vector2 Rot2, bool Flipped = false)
        {
            GameObject PortalA = new GameObject("Portal One", new Type[]
            {
                typeof(SpriteRenderer),
                typeof(RavenPortalBehaviour)
            });
			GameObject PortalGlowA = new GameObject("Portal Glow One", new Type[]
			{
				typeof(SpriteRenderer)
			});
			GameObject PortalColliderA = new GameObject("PortCol", new Type[]
			{
				typeof(SpriteRenderer)
			});
			GameObject PortalColliderB = new GameObject("PortCol", new Type[]
			{
				typeof(SpriteRenderer)
			});
			GameObject MaskA = new GameObject("Portal Mask");
			var mask = MaskA.AddComponent(Type.GetType("UnityEngine.SpriteMask, UnityEngine")) as Renderer;
			PortalA.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_PortalPower;
			PortalA.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
            PortalA.layer = 9;
            PortalA.AddComponent<BoxCollider2D>().isTrigger = true;
			PortalA.transform.localScale *= new Vector2(3f, 2f);
			PortalA.AddComponent<TriggerEventBehaviour>();
			RavenPortalBehaviour Port = PortalA.GetComponent<RavenPortalBehaviour>();
            Port.layer = SortingLayer.NameToID("Default"); //See if this works
            PortalA.transform.position = Pos1;
			PortalGlowA.transform.SetParent(PortalA.transform);
			PortalGlowA.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_RavenPortalGlow;
			PortalGlowA.transform.localScale = Vector2.one;
			PortalGlowA.transform.SetPositionAndRotation(new Vector2(PortalA.GetComponent<SpriteRenderer>().bounds.min.x + PortalGlowA.GetComponent<SpriteRenderer>().bounds.min.x, PortalA.GetComponent<SpriteRenderer>().bounds.center.y), PortalA.transform.rotation);
			PortalColliderA.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_RavenPortalCol;
			PortalColliderA.GetComponent<SpriteRenderer>().color = Color.clear;
			PortalColliderA.transform.SetParent(PortalA.transform);
			PortalColliderA.transform.position = new Vector2(PortalA.GetComponent<SpriteRenderer>().bounds.center.x, PortalA.GetComponent<SpriteRenderer>().bounds.max.y + PortalColliderA.GetComponent<SpriteRenderer>().bounds.max.y);
			PortalColliderA.transform.localScale = Vector2.one;
			PortalColliderA.transform.right = PortalA.transform.right;
			PortalColliderB.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_RavenPortalCol;
			PortalColliderB.GetComponent<SpriteRenderer>().color = Color.clear;
			PortalColliderB.transform.SetParent(PortalA.transform);
			PortalColliderB.transform.position = new Vector2(PortalA.GetComponent<SpriteRenderer>().bounds.center.x, PortalA.GetComponent<SpriteRenderer>().bounds.min.y + PortalColliderB.GetComponent<SpriteRenderer>().bounds.min.y);
			PortalColliderB.transform.localScale = Vector2.one;
			PortalColliderB.transform.right = PortalA.transform.right;
			MaskA.transform.SetParent(PortalA.transform);
			MaskA.transform.localScale = new Vector2(80f, 6f);
			mask.sortingLayerName = "Portals";
			PropertyInfo testTing = Type.GetType("UnityEngine.SpriteMask, UnityEngine").GetProperty("sprite");
			testTing.SetValue(mask, ResourceStorage.Sprite_RavenPortal);
			Type.GetType("UnityEngine.SpriteMask, UnityEngine").GetProperty("frontSortingLayerID").SetValue(mask, SortingLayer.NameToID("Foreground"));
			Type.GetType("UnityEngine.SpriteMask, UnityEngine").GetProperty("backSortingLayerID").SetValue(mask, SortingLayer.NameToID("Background"));
			Type.GetType("UnityEngine.SpriteMask, UnityEngine").GetProperty("isCustomRangeActive").SetValue(mask, true);
			MaskA.transform.position = new Vector2(PortalA.GetComponent<SpriteRenderer>().bounds.min.x + mask.bounds.min.x, PortalA.GetComponent<SpriteRenderer>().bounds.center.y);
			MaskA.transform.right = PortalA.transform.right;
			PortalA.transform.right = Rot1;
			Port.EntryTriggerEvent = PortalA.GetComponent<TriggerEventBehaviour>();
			//PortalGlowA.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
			PortalColliderA.AddComponent<BoxCollider2D>();
			PortalColliderA.layer = 9;
			PortalColliderB.AddComponent<BoxCollider2D>();
			PortalColliderB.layer = 9;
			Port.GoLeft = Flipped;

			GameObject PortalB = new GameObject("Portal Two", new Type[]
            {
                typeof(SpriteRenderer),
                typeof(RavenPortalBehaviour)
			});
			GameObject PortalGlowB = new GameObject("Portal Glow Two", new Type[]
			{
				typeof(SpriteRenderer)
			});
			GameObject PortalColliderC = new GameObject("PortCol", new Type[]
			{
				typeof(SpriteRenderer)
			});
			GameObject PortalColliderD = new GameObject("PortCol", new Type[]
			{
				typeof(SpriteRenderer)
			});
			GameObject MaskB = new GameObject("Portal Mask");
			var maskB = MaskB.AddComponent(Type.GetType("UnityEngine.SpriteMask, UnityEngine")) as Renderer;
			PortalB.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_RavenPortal;
			PortalB.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
            PortalB.layer = 9;
            PortalB.AddComponent<BoxCollider2D>().isTrigger = true;
			PortalB.transform.localScale *= new Vector2(3f, 2f);
			PortalB.AddComponent<TriggerEventBehaviour>();
			RavenPortalBehaviour PortB = PortalB.GetComponent<RavenPortalBehaviour>();
            PortB.layer = SortingLayer.NameToID("Portals"); //See if this works
			PortB.GoLeft = !Flipped;
            PortalB.transform.position = Pos2;
			PortalGlowB.transform.SetParent(PortalB.transform);
			PortalGlowB.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_RavenPortalGlow;
			PortalGlowB.transform.localScale = Vector2.one;
			PortalGlowB.transform.position = new Vector2(PortalB.GetComponent<SpriteRenderer>().bounds.max.x - PortalGlowB.GetComponent<SpriteRenderer>().bounds.max.x, PortalB.GetComponent<SpriteRenderer>().bounds.center.y);
			PortalGlowB.transform.right = PortalB.transform.right;
			PortB.EntryTriggerEvent = PortalB.GetComponent<TriggerEventBehaviour>();
			MaskB.transform.SetParent(PortalB.transform);
			MaskB.transform.localScale = new Vector2(80f, 6f);
			maskB.sortingLayerName = "Portals";
			PropertyInfo testTingB = Type.GetType("UnityEngine.SpriteMask, UnityEngine").GetProperty("sprite");
			testTingB.SetValue(maskB, ResourceStorage.Sprite_RavenPortal);
			Type.GetType("UnityEngine.SpriteMask, UnityEngine").GetProperty("frontSortingLayerID").SetValue(maskB, SortingLayer.NameToID("Foreground"));
			Type.GetType("UnityEngine.SpriteMask, UnityEngine").GetProperty("backSortingLayerID").SetValue(maskB, SortingLayer.NameToID("Background"));
			Type.GetType("UnityEngine.SpriteMask, UnityEngine").GetProperty("isCustomRangeActive").SetValue(maskB, true);
			MaskB.transform.position = new Vector2((PortalB.GetComponent<SpriteRenderer>().bounds.max.x - maskB.bounds.max.x), PortalB.GetComponent<SpriteRenderer>().bounds.center.y);
			MaskB.transform.right = PortalB.transform.right;
			PortalColliderC.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_RavenPortalCol;
			PortalColliderC.GetComponent<SpriteRenderer>().color = Color.clear;
			PortalColliderC.transform.SetParent(PortalB.transform);
			PortalColliderC.transform.position = new Vector2(PortalB.GetComponent<SpriteRenderer>().bounds.center.x, PortalB.GetComponent<SpriteRenderer>().bounds.max.y + PortalColliderD.GetComponent<SpriteRenderer>().bounds.max.y);
			PortalColliderC.transform.localScale = Vector2.one;
			PortalColliderC.transform.right = PortalB.transform.right;
			PortalColliderC.AddComponent<BoxCollider2D>();
			PortalColliderC.layer = 9;
			PortalColliderD.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_RavenPortalCol;
			PortalColliderD.GetComponent<SpriteRenderer>().color = Color.clear;
			PortalColliderD.transform.SetParent(PortalB.transform);
			PortalColliderD.transform.position = new Vector2(PortalB.GetComponent<SpriteRenderer>().bounds.center.x, PortalB.GetComponent<SpriteRenderer>().bounds.min.y + PortalColliderD.GetComponent<SpriteRenderer>().bounds.min.y);
			PortalColliderD.transform.localScale = Vector2.one;
			PortalColliderD.transform.right = PortalB.transform.right;
			PortalColliderD.AddComponent<BoxCollider2D>();
			PortalColliderD.layer = 9;
			PortalB.transform.right = Rot2;
			//PortalGlowB.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
			

			Port.OtherEnd = PortB;
            PortB.OtherEnd = Port;
			PortB.ExitTriggerEvent = PortalB.GetComponent<TriggerEventBehaviour>();
			Port.ExitTriggerEvent = PortalA.GetComponent<TriggerEventBehaviour>();

			ModAPI.CreateParticleEffect("Disintegration", PortalA.transform.position);
			ModAPI.CreateParticleEffect("Disintegration", PortalB.transform.position);

			UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(PortalA, "Portals"));

			return new GameObject[]
			{
				PortalA,
				PortalB
			};
		}

		public class HasEnteredPortal : MonoBehaviour
        {
			private void Awake()
            {
				this.StartCoroutine(Timer());
            }

			public IEnumerator Timer()
            {
				yield return new WaitForSeconds(0.1f);
				this.gameObject.GetComponent<SpriteRenderer>().maskInteraction = SpriteMaskInteraction.None;
				GameObject.Destroy(this);
            }
		}

		public class RavenPortalBehaviour : MonoBehaviour
		{
			private void Awake()
			{
				this.objectRenderer = new GameObject("Portal clone renderer");
				this.objectRenderer.transform.position = Vector3.zero;
				this.Aud = this.gameObject.AddComponent<AudioSource>();
				this.Aud.clip = ResourceStorage.Sound_Portal2EnterSfx;
				this.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
			}

			private void Start()
			{
				this.EntryTriggerEvent.OnTriggerEnter = new UnityAction<Collider2D>(this.StartPassage);
				this.ExitTriggerEvent.OnTriggerExit = new UnityAction<Collider2D>(this.StartExit);
			}

			public void StartPassage(Collider2D obj)
			{
				PhysicalBehaviour physicalBehaviour;
				if (!Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(obj.transform, out physicalBehaviour) || !physicalBehaviour || this.passingThrough.ContainsKey(physicalBehaviour) || physicalBehaviour.gameObject.GetComponent<HasEnteredPortal>())
				{
					return;
				}
				Vector2 PosStuff = this.transform.position - physicalBehaviour.transform.position;
				Debug.Log(Vector2.Dot(PosStuff, -this.transform.right));
				if ((!this.GoLeft) ? (Vector2.Dot(PosStuff, -this.transform.right) >= 0) : (Vector2.Dot(this.transform.right, PosStuff) <= 0))
				{
					return;
				}
				SpriteRenderer spriteRenderer = new GameObject(obj.gameObject.name + " ghost").AddComponent<SpriteRenderer>();
				spriteRenderer.sprite = physicalBehaviour.spriteRenderer.sprite;
				spriteRenderer.maskInteraction = SpriteMaskInteraction.VisibleInsideMask;
				spriteRenderer.sortingLayerName = physicalBehaviour.spriteRenderer.sortingLayerName;
				spriteRenderer.sortingOrder = physicalBehaviour.spriteRenderer.sortingOrder;
				Debug.Log(SortingLayer.IDToName(physicalBehaviour.spriteRenderer.sortingLayerID));
				this.passingThrough.Add(physicalBehaviour, spriteRenderer);
				physicalBehaviour.gameObject.GetOrAddComponent<RavenPortalTraversingBehaviour>().enabled = true;
			}

			public void StartExit(Collider2D collision)
			{
				PhysicalBehaviour physicalBehaviour;
				SpriteRenderer spriteRenderer;
				if (!Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out physicalBehaviour) || !this.passingThrough.TryGetValue(physicalBehaviour, out spriteRenderer))
				{
					return;
				}
				Vector2 PosStuff = this.transform.position - physicalBehaviour.transform.position;
				if ((!this.GoLeft) ? (Vector2.Dot(PosStuff, -this.transform.right) >= 0) : (Vector2.Dot(this.transform.right, PosStuff) <= 0))
				{
					foreach (PhysicalBehaviour phys in physicalBehaviour.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
					{
						if (!this.passingThrough.ContainsKey(phys))
						{
							return;
						}
					}
					foreach (PhysicalBehaviour phys in physicalBehaviour.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
					{
						if (this.passingThrough.ContainsKey(phys))
						{
							phys.transform.position = this.passingThrough[phys].transform.position;
							phys.transform.right = this.passingThrough[phys].transform.right;
							//phys.transform.localScale = this.passingThrough[phys].transform.localScale;
							Vector3 OutDir = this.OtherEnd.transform.TransformDirection(this.transform.InverseTransformDirection(phys.rigidbody.velocity));
							phys.rigidbody.velocity = new Vector2(-OutDir.x, -OutDir.y);
							phys.rigidbody.velocity *= 1.05f;
							UnityEngine.Object.Destroy(this.passingThrough[phys].gameObject);
							this.passingThrough.Remove(phys);
							phys.gameObject.AddComponent<HasEnteredPortal>();
							RavenPortalTraversingBehaviour portalTraversingBehaviour;
							if (phys && phys.gameObject.TryGetComponent<RavenPortalTraversingBehaviour>(out portalTraversingBehaviour))
							{
								portalTraversingBehaviour.enabled = false;
							}
						}
					}
					this.Aud.Play();
				}
				else
                {
					UnityEngine.Object.Destroy(this.passingThrough[physicalBehaviour].gameObject);
					this.passingThrough.Remove(physicalBehaviour);
					physicalBehaviour.gameObject.AddComponent<HasEnteredPortal>();
					RavenPortalTraversingBehaviour portalTraversingBehaviour;
					if (physicalBehaviour && physicalBehaviour.gameObject.TryGetComponent<RavenPortalTraversingBehaviour>(out portalTraversingBehaviour))
					{
						portalTraversingBehaviour.enabled = false;
					}
				}
				Debug.Log("Test Two, " + collision.gameObject.name);
			}

			private void OnWillRenderObject()
			{
				if (this.OtherEnd)
				{
					this.RenderObjectClones();
				}
			}

			private void RenderObjectClones()
			{
				Transform transform = this.OtherEnd.transform;
				foreach (KeyValuePair<PhysicalBehaviour, SpriteRenderer> keyValuePair in this.passingThrough)
				{
					PhysicalBehaviour key = keyValuePair.Key;
					SpriteRenderer value = keyValuePair.Value;
					if (key)
					{
						Vector3 a = base.transform.InverseTransformPoint(key.transform.position);
						Vector3 position = transform.TransformPoint(new Vector3(-a.x, -a.y, a.z));
						//Vector3 direction = base.transform.InverseTransformDirection(-key.transform.right); //-
						//Vector3 right = transform.TransformDirection(direction);
						value.transform.position = position;
						//value.transform.right = right;
						value.transform.right = key.transform.right;
						value.transform.localScale = key.transform.lossyScale;
					}
				}
			}

			private void OnDestroy()
			{
				UnityEngine.Object.Destroy(this.objectRenderer);
				UnityEngine.Object.Destroy(this.OtherEnd.gameObject);
			}

			public RavenPortalBehaviour OtherEnd;
			public TriggerEventBehaviour EntryTriggerEvent;
			public TriggerEventBehaviour ExitTriggerEvent;
			public int layer;
			private AudioSource Aud;
			public bool GoLeft;
			private Dictionary<PhysicalBehaviour, SpriteRenderer> passingThrough = new Dictionary<PhysicalBehaviour, SpriteRenderer>();
			private GameObject objectRenderer;
		}

		public class RavenPortalTraversingBehaviour : MonoBehaviour
		{
			public void OnEnable()
			{
				base.gameObject.GetComponent<SpriteRenderer>().maskInteraction = SpriteMaskInteraction.VisibleInsideMask;
				this.Disabled = false;
			}

			public void OnDisable()
            {
				this.Disabled = true;
				foreach (var col in this.Cols)
                {
					Physics2D.IgnoreCollision(this.gameObject.GetComponent<Collider2D>(), col, false);
				}
			}

			public void OnCollisionEnter2D(Collision2D col)
            {
				if (col.transform.root.gameObject.GetComponent<RavenPortalBehaviour>() || this.Disabled)
                {
					return;
                }
				Physics2D.IgnoreCollision(col.otherCollider, col.collider);
				Cols.Add(col.collider);
			}
			private List<Collider2D> Cols = new List<Collider2D>();
			private bool Disabled;
		}
	}
}
