﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    // _________ _______  _______  _______            _________ _        _______  _______  _       
    // \__   __/(  ____ \(  ___  )(       )  |\     /|\__   __/( \      (  ____ \(  ___  )( (    /|  😂
    //    ) (   | (    \/| (   ) || () () |  | )   ( |   ) (   | (      | (    \/| (   ) ||  \  ( |  
    //    | |   | (__    | (___) || || || |  | | _ | |   | |   | |      | (_____ | |   | ||   \ | |  
    //    | |   |  __)   |  ___  || |(_)| |  | |( )| |   | |   | |      (_____  )| |   | || (\ \) |  
    //    | |   | (      | (   ) || |   | |  | || || |   | |   | |            ) || |   | || | \   |  
    //    | |   | (____/\| )   ( || )   ( |  | () () |___) (___| (____/\/\____) || (___) || )  \  |  
    //    )_(   (_______/|/     \||/     \|  (_______)\_______/(_______/\_______)(_______)|/    )_) 
    //
    // This framework was created by Team Wilson and is allowed to be used in any mod as long as The Power Pack Framework is a required mod (otherwise may be errors).
    // Link to PPF: https://steamcommunity.com/sharedfiles/filedetails/?id=2506978276
    // Framework coded by 🥧 Camdog74 🥧

    public class ResourceStorage : MonoBehaviour
    {

        //This is where you store all of your assets like your sprites, textures and sounds. (power icons too)
        //Make sure to add new ones when you need to use them instead of using ModAPI.Load in AfterSpawn.

        #region Textures
        public static Texture2D Skin_Batman = ModAPI.LoadTexture("Assets/People/Batman/skin layer.png");
        public static Texture2D Skin_BlackCanary = ModAPI.LoadTexture("Assets/People/Black Canary/skin layer.png");
        public static Texture2D Skin_JimGordon = ModAPI.LoadTexture("Assets/People/Jim Gordon/skin layer.png");
        public static Texture2D Skin_GreenArrow = ModAPI.LoadTexture("Assets/People/Green Arrow/skin layer.png");
        public static Texture2D Skin_TheFlash = ModAPI.LoadTexture("Assets/People/flash/skin layer.png");
        public static Texture2D Skin_KidFlash = ModAPI.LoadTexture("Assets/People/Kid Flash/skin layer.png");
        public static Texture2D Skin_Shazam = ModAPI.LoadTexture("Assets/People/shazam/skin layer.png");
        public static Texture2D Skin_ShazamSuit = ModAPI.LoadTexture("Assets/People/shazam/skin layer shazam.png");
        public static Texture2D Skin_ReverseFlash = ModAPI.LoadTexture("Assets/People/Reverse Flash/skin layer.png");
        public static Texture2D Skin_Zoom = ModAPI.LoadTexture("Assets/People/zoom/skin layer.png");
        public static Texture2D Skin_Superman = ModAPI.LoadTexture("Assets/People/Superman/skin layer.png");
        public static Texture2D Skin_Martian = ModAPI.LoadTexture("Assets/People/Martin MaleMurderer/skin layer.png");
        public static Texture2D Skin_Lex = ModAPI.LoadTexture("Assets/People/Lex/skin.png");
        public static Texture2D PoisenIvy = ModAPI.LoadTexture("Assets/People/ivy/skin layer.png");
        public static Texture2D DeadShot = ModAPI.LoadTexture("Assets/People/deadshot/skin layer.png");
        public static Texture2D Skin_Darkseid = ModAPI.LoadTexture("Assets/People/Darkseid/skin layer.png");
        public static Texture2D Skin_Joker = ModAPI.LoadTexture("Assets/People/Joker/skin layer.png");
        public static Texture2D Skin_Robin = ModAPI.LoadTexture("Assets/People/robin/skin layer.png");
        public static Texture2D Skin_Superboy = ModAPI.LoadTexture("Assets/People/Superboy/skin layer.png");
        public static Texture2D Skin_Damian = ModAPI.LoadTexture("Assets/People/Damian/skin layer.png");
        public static Texture2D Skin_RedX = ModAPI.LoadTexture("Assets/People/RedX/skin layer.png");
        public static Texture2D Skin_Harley = ModAPI.LoadTexture("Assets/People/Harley Quinn/skin layer.png");
        public static Texture2D Skin_Deadshot = ModAPI.LoadTexture("Assets/People/Deadshot/skin layer.png");
        public static Texture2D Skin_Cyborg = ModAPI.LoadTexture("Assets/People/Cyborg/skin layer.png");
        public static Texture2D Skin_CyborgFlesh = ModAPI.LoadTexture("Assets/People/Cyborg/flesh layer.png");
        public static Texture2D Skin_CyborgBone = ModAPI.LoadTexture("Assets/People/Cyborg/bone layer.png");
        public static Texture2D Skin_RedHood = ModAPI.LoadTexture("Assets/People/Red Hood/skin layer.png");
        public static Texture2D Skin_CatWomen = ModAPI.LoadTexture("Assets/People/Cat Women/skin layer.png");
        public static Texture2D Skin_Batgirl = ModAPI.LoadTexture("Assets/People/Batgirl/skin layer.png");
        public static Texture2D Skin_DamianRobin = ModAPI.LoadTexture("Assets/People/Damian/skin layer.png");
        public static Texture2D Skin_DeathStroke = ModAPI.LoadTexture("Assets/People/DeathStroke/Skin Layer.png");
        public static Texture2D Skin_DeathStrokeFlipped = ModAPI.LoadTexture("Assets/People/DeathStroke/Skin Layer Flipped.png");
        public static Texture2D Skin_Bane = ModAPI.LoadTexture("Assets/People/Bane/skin layer.png");
        public static Texture2D Skin_BaneBoosted = ModAPI.LoadTexture("Assets/People/Bane/skin layer hulky.png");
        public static Texture2D Skin_GreenLantern = ModAPI.LoadTexture("Assets/People/Green Lantern/Skin Layer.png");
        public static Texture2D Texture_Fist = ModAPI.LoadTexture("Assets/People/Green Lantern/Fist.png");
        public static Texture2D Skin_Sinestro = ModAPI.LoadTexture("Assets/People/Sinestro/Skin Layer.png");
        public static Texture2D Skin_Aquaman = ModAPI.LoadTexture("Assets/People/Aquaman/Skin Layer.png");
        public static Texture2D Skin_Hawkman = ModAPI.LoadTexture("Assets/People/Hawkman/Skin Layer.png");
        public static Texture2D Skin_Nightwing = ModAPI.LoadTexture("Assets/People/Nightwing/Skin Layer.png");
        public static Texture2D Skin_JohnConstantine = ModAPI.LoadTexture("Assets/People/John Constantine/Skin Layer.png");
        public static Texture2D Skin_WonderWoman = ModAPI.LoadTexture("Assets/People/Wonder Women/Skin Layer.png");
        public static Texture2D Texture_Laser = ModAPI.LoadTexture("Assets/People/Lex/Mech/Laser.png");
        public static Texture2D Texture_DamageMask = ModAPI.LoadTexture("Assets/People/Lex/Mech/DamageMask.png");
        public static Texture2D Texture_ElectronicMask = new Texture2D(1, 1);
        #endregion

        #region AnimatedSprites
        public static List<Sprite> VibrateAnimation = new List<Sprite>()
           {ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00000.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00001.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00002.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00003.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00004.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00005.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00006.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00007.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00008.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00009.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00010.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00011.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00012.png"),
            ModAPI.LoadSprite("Assets/People/Flash/VibrateSprite/SpeedsterVibrate_00013.png")};
        #endregion

        #region Sprites
        public static Sprite Sprite_BatmanCape = ModAPI.LoadSprite("Assets/People/Batman/TestCape.png");
        public static Sprite Sprite_HeadExploderPowerIcon = ModAPI.LoadSprite("Assets/Icons/Head Exploder.png");
        public static Sprite Sprite_JokerLaughPowerIcon = ModAPI.LoadSprite("Assets/Icons/JokerLaugh.png");
        public static Sprite Sprite_LaserVisionPowerIcon = ModAPI.LoadSprite("Assets/Icons/laser.png");
        public static Sprite Sprite_SpeedPowerIcon = ModAPI.LoadSprite("Assets/Icons/FlashPower.png");
        public static Sprite Sprite_PortalPower = ModAPI.LoadSprite("Assets/Icons/PortalPower.png");
        public static Sprite Sprite_SupermanEyes = ModAPI.LoadSprite("Assets/People/Superman/Eyes.png");
        public static Sprite Sprite_MarsEyes = ModAPI.LoadSprite("Assets/People/Martin MaleMurderer/Eyes1.png");
        public static Sprite Sprite_SupermanCape = ModAPI.LoadSprite("Assets/People/Superman/cape02.png");
        public static Sprite Sprite_SupermanCapeBase = ModAPI.LoadSprite("Assets/People/Superman/cape01.png");
        public static Sprite Sprite_BatarangLight = ModAPI.LoadSprite("Assets/People/Batman/BatarangLight.png");
        public static Sprite Sprite_BatarangProngs = ModAPI.LoadSprite("Assets/People/Batman/BatarangProngs.png");
        public static Sprite Sprite_Pizza = ModAPI.LoadSprite("Assets/People/Batman/Pizza.png");
        public static Sprite Sprite_PoeiaSprite = ModAPI.LoadSprite("Assets/OtherStuff/RRang.png");
        public static Sprite Sprite_RavenPortal = ModAPI.LoadSprite("Assets/OtherStuff/PortalSprite.png");
        public static Sprite Sprite_RavenPortalCol = ModAPI.LoadSprite("Assets/OtherStuff/PortalSpriteCol.png");
        public static Sprite Sprite_RavenPortalGlow = ModAPI.LoadSprite("Assets/OtherStuff/PortalGlowSprite.png");
        public static Sprite Sprite_BatmanCapeBase = ModAPI.LoadSprite("Assets/People/Batman/cape01.png");
        public static Sprite Sprite_BatgirlCape = ModAPI.LoadSprite("Assets/People/Batgirl/cape02.png");
        public static Sprite Sprite_BatgirlCapeBase = ModAPI.LoadSprite("Assets/People/Batgirl/cape01.png");
        public static Sprite Sprite_MartianCape = ModAPI.LoadSprite("Assets/People/Martin MaleMurderer/cape02.png");
        public static Sprite Sprite_MartianCapeBase = ModAPI.LoadSprite("Assets/People/Martin MaleMurderer/cape01.png");
        public static Sprite Sprite_RedHoodGun = ModAPI.LoadSprite("Assets/People/Red Hood/pistol.png", 2);
        public static Sprite Sprite_RedHoodGunIcon = ModAPI.LoadSprite("Assets/People/Red Hood/gun thumb.png");
        public static Sprite Sprite_DeadShotGun = ModAPI.LoadSprite("Assets/People/DeadShot/gun.PNG", 1.5f);
        public static Sprite Sprite_DeadShotGunIcon = ModAPI.LoadSprite("Assets/People/DeadShot/gunthumb.png");
        public static Sprite Sprite_SpeedsterPhasePowerIcon = ModAPI.LoadSprite("Assets/Icons/Speedster Phase.png");
        public static Sprite Sprite_SpeedsterTimeStopPowerIcon = ModAPI.LoadSprite("Assets/Icons/Speedster Time Stop.png");
        public static Sprite Sprite_BaneBoosterPowerIcon = ModAPI.LoadSprite("Assets/Icons/Bane Booster.png");
        public static Sprite Sprite_CyborgBlasterPowerIcon = ModAPI.LoadSprite("Assets/Icons/Cyborg Blaster.png");
        public static Sprite Sprite_GreenLanternFist_Particle = ModAPI.LoadSprite("Assets/People/Green Lantern/Fist - Copy.png");
        public static Sprite Sprite_FistProjectionPowerIcon = ModAPI.LoadSprite("Assets/Icons/Flying Fist.png");
        public static Sprite Sprite_NightwingBat_1 = ModAPI.LoadSprite("Assets/People/Nightwing/Baton Button.png");
        public static Sprite Sprite_NightwingBat_2 = ModAPI.LoadSprite("Assets/People/Nightwing/Baton.png");
        public static Sprite Sprite_AquamansTrident = ModAPI.LoadSprite("Assets/People/Aquaman/Aquaman's Trident.png");
        public static Sprite Sprite_MagicPushPowerIcon = ModAPI.LoadSprite("Assets/Icons/Magic Push.png");
        public static Sprite Sprite_Hook = ModAPI.LoadSprite("Assets/OtherStuff/GrapnelHook.png");
        public static Sprite Sprite_SwordCol = ModAPI.LoadSprite("Assets/People/Lex/Mech/SwordBounds.png");
        public static Sprite Sprite_RocketCol = ModAPI.LoadSprite("Assets/People/Lex/Mech/RocketBounds.png");
        public static Sprite Sprite_Sword = ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Lightybeamysword.png");
        public static Sprite Sprite_Rocket = ModAPI.LoadSprite("Assets/People/Lex/Mech/LexRocket.png", 2f);
        #endregion

        #region Sounds
        public static AudioClip Sound_BlackCanaryScream1 = ModAPI.LoadSound("Assets/People/Black Canary/Scream01.wav");
        public static AudioClip Sound_BlackCanaryScream2 = ModAPI.LoadSound("Assets/People/Black Canary/Scream02.wav");
        public static AudioClip Sound_BlackCanaryScream3 = ModAPI.LoadSound("Assets/People/Black Canary/Scream03.wav");
        public static AudioClip Sound_Joker1 = ModAPI.LoadSound("Assets/People/Joker/joker.mp3");
        public static AudioClip Sound_Joker2 = ModAPI.LoadSound("Assets/People/Joker/joker B.mp3");
        public static AudioClip Sound_Joker3 = ModAPI.LoadSound("Assets/People/Joker/joker C.mp3");
        public static AudioClip Sound_LaserOn = ModAPI.LoadSound("Assets/People/Cyborg/LasOn.wav");
        public static AudioClip Sound_LaserConstant = ModAPI.LoadSound("Assets/People/Cyborg/LasConstant.wav");
        public static AudioClip Sound_LaserOff = ModAPI.LoadSound("Assets/People/Cyborg/LasOff.wav");
        public static AudioClip Sound_SLaserConstant = ModAPI.LoadSound("Assets/OtherStuff/LasConstant.wav");
        public static AudioClip Sound_SLaserOff = ModAPI.LoadSound("Assets/OtherStuff/LasOff.wav");
        public static AudioClip Sound_ExplosiveBatarangSFX = ModAPI.LoadSound("Assets/People/Batman/ExploRang.wav");
        public static AudioClip Sound_ElectricBatarangSFX = ModAPI.LoadSound("Assets/People/Batman/BatarangElectricDischarge.wav");
        public static AudioClip Sound_GrappleShoot = ModAPI.LoadSound("Assets/People/Batman/Launch.wav");
        public static AudioClip Sound_GrapplePull = ModAPI.LoadSound("Assets/People/Batman/Pull.wav");
        public static AudioClip Sound_Portal2EnterSfx = ModAPI.LoadSound("Assets/OtherStuff/Portal2EnterSfx.wav");
        public static AudioClip Sound_ShazamYellingLikeAnIdiot = ModAPI.LoadSound("Assets/People/Shazam/yell.wav");
        public static AudioClip Sound_SpeedsterPhaseStart = ModAPI.LoadSound("Assets/People/Flash/Phase start.wav");
        public static AudioClip Sound_SpeedsterPhaseLoop = ModAPI.LoadSound("Assets/People/Flash/Phase Loop.wav");
        public static AudioClip Sound_FunnyComicSound = ModAPI.LoadSound("Assets/OtherStuff/funny.wav");
        public static AudioClip Sound_GreenLanternFist_Shot = ModAPI.LoadSound("Assets/People/Green Lantern/Fist Shot.wav");
        public static AudioClip Sound_GreenLanternFist_Amb = ModAPI.LoadSound("Assets/People/Green Lantern/Fist_Amb.wav");
        public static AudioClip Sound_OmegaBeam = ModAPI.LoadSound("Assets/People/Darkseid/OmegaBeam.wav");
        public static AudioClip Sound_MagicPushSound = ModAPI.LoadSound("Assets/People/John Constantine/Magic Push Sound.wav");
        public static AudioClip Sound_Draw = ModAPI.LoadSound("Assets/OtherStuff/Draw.wav");
        #endregion
    }

    public class DCPP
    {
        //Make sure all objects start with this tag, below is an example:
        //NameOverride = DCppTag + "Black Canary"
        static string DCppTag = " <color=red>[DCPP] <color=white>";
        public static void Main()
        {
            


            ResourceStorage.Texture_Laser.wrapMode = TextureWrapMode.Repeat;
            ResourceStorage.Texture_Laser.Apply();
            ResourceStorage.Texture_DamageMask.wrapMode = TextureWrapMode.Repeat;
            ResourceStorage.Texture_DamageMask.Apply();
            ResourceStorage.Texture_ElectronicMask.SetPixel(0, 0, Color.clear);
            ResourceStorage.Texture_ElectronicMask.Apply();
            CategoryBuilder.Create("DC Power Pack", "Contains many DC heroes and powers. - Team Wilson", ModAPI.LoadSprite("logo_category.png"));

            GameObject ResourceManager = new GameObject();
            ResourceManager.AddComponent<ResourceStorage>();


            //Registering items and characters
            #region Syringes
            // Lethal Scream Syringe
            Liquid.Register("JOKERPOISON", new JokerPoison());
            Liquid.Register("SCREAMPOISON", new LethalScreamPoison());
            Liquid.Register("LASERPOISON", new laserPoison());
            Liquid.Register("TIMESTOPPOISON", new TimeStopPoison());
            Liquid.Register("VIBRATEPOISON", new SpeedsterVibratePoison());
            Liquid.Register("MAGICPUSHPOISON", new MagicPushPoison());
            Liquid.Register("FLYINGPOISON", new FlyingPoison());
            Liquid.Register("FISTPROJECTIONPOISON", new FistProjectionPoison());
            Liquid.Register("BANEBOOSTPOISON", new BaneBoostPoison());
            Liquid.Register("OMEGABEAMPOISON", new OmegaBeamPoison());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                    NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Lethal Scream Syringe", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Interact with head to blow up heads with a lethal scream.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Black Canary/Thumb2.png"), //new item thumbnail (relative path)                           //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.AddComponent<LethalScreamSyringe>();
                        ///Instance.GetComponent<SpriteRenderer>().color = Color.cyan;
                    }
                }
            );

            //Joker Laugh Syringe
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                    NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Joker Laugh Syringe", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Interact with the head to laugh like Joker.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Joker/Thumb2.png"), //new item thumbnail (relative path)                           //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.AddComponent<JokerLaughSyringe>();
                        ///Instance.GetComponent<SpriteRenderer>().color = Color.green;
                    }
                }
            );

            //Time Stop Syringe
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                    NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Time Stop Syringe", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Interact with the head to freeze time.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Flash/thumb2.png"), //new item thumbnail (relative path) Please give me a unique thumbnail!                         //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.AddComponent<TimeStopSyringeBehaviour>();
                        ///Instance.GetComponent<SpriteRenderer>().color = Color.white;
                    }
               }
           );

            //Laser Eye Syringe
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                    NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Laser Eye Syringe", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Interact with head to shoot a laser", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/superman/Thumb2.png"), //new item thumbnail (relative path)                           //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.AddComponent<LaserEyeSyringe>();
                        ///Instance.GetComponent<SpriteRenderer>().color = Color.red;
                    }
                }
            );

            //OmegaBeam Syringe
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                    NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Omega Beam Syringe", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Interact with the head to blast a powerful Omega Beam.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Darkseid/syrthumb.png"), //new item thumbnail (relative path)                           //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        GameObject.Destroy(Instance.GetComponent<EmptySyringe>());
                        Instance.AddComponent<OmegaBeamSyringe>();
                    }
                }
            );

            //Speedster Vibrate Syringe
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                   NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Speedster Vibrate Syringe", //new item name with a suffix to assure it is globally unique
                   DescriptionOverride = "Interact with the hand to vibrate through objects and damage them.", //new item description
                   CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                   ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Flash/thumb3.png"), //new item thumbnail (relative path) Please give me a unique thumbnail!                         //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                   AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                   {
                       Instance.AddComponent<VibrateSyringeBehaviour>();
                   }
               }
           );

            //Magic Push Syringe
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                   NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Magic Push Syringe", //new item name with a suffix to assure it is globally unique
                   DescriptionOverride = "Interact with the hand and aim at someone to send them flying.", //new item description
                   CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                   ThumbnailOverride = ModAPI.LoadSprite("Assets/People/John Constantine/Syringe Thumb.png"), //new item thumbnail (relative path) Please give me a unique thumbnail!                         //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                   AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                   {
                       Instance.AddComponent<MagicPushSyringeBehaviour>();
                   }
               }
           );

            //Flying Syringe
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                   NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Flying Syringe", //new item name with a suffix to assure it is globally unique
                   DescriptionOverride = "Right click the user and click toggle fly to do so.", //new item description
                   CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                   ThumbnailOverride = ModAPI.LoadSprite("Assets/OtherStuff/Flying Syringe.png"), //new item thumbnail (relative path) Please give me a unique thumbnail!                         //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                   AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                   {
                       Instance.AddComponent<FlyingSyringeBehaviour>();
                   }
               }
           );

            //Fist Projection Syringe
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                   NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Fist Projection Syringe", //new item name with a suffix to assure it is globally unique
                   DescriptionOverride = "Interact with hand to shoot a projection fist.", //new item description
                   CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                   ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Green Lantern/Syringe Thumb.png"), //new item thumbnail (relative path) Please give me a unique thumbnail!                         //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                   AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                   {
                       Instance.AddComponent<FistProjectionBehaviour>();
                   }
               }
           );

            //Fist Projection Syringe
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
                   NameOverride = DCppTag + "<color=red>[SYRINGE]<color=white> Bane Boost Syringe", //new item name with a suffix to assure it is globally unique
                   DescriptionOverride = "Interact with the user's head give them Bane's boost for 12 seconds.", //new item description
                   CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                   ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Bane/Syringe Thumb.png"), //new item thumbnail (relative path) Please give me a unique thumbnail!                         //   ThumbnailOverride = ModAPI.LoadSprite("blueMan.png"), //new item thumbnail (relative path)
                   AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                   {
                       Instance.AddComponent<BaneBoostBehaviour>();
                   }
               }
           );

            #endregion

            #region Weapons
            //Green Arrows Bow
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"), //item to derive from
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Green Arrow's Bow", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "One Shot One Kill - Green Arrow\nOpen up the context menu to change which type of arrow is shot.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/people/Green Arrow/BowThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assets/people/Green Arrow/Bow.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        Instance.transform.localScale *= 1.0f;
                        Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[] { Vector3.zero };
                        Instance.GetComponent<PhysicalBehaviour>().RecalculateMassBasedOnSize();
                        Instance.AddComponent<GreenBowBehaviour>();
                        Instance.FixColliders();
                    }
                }
            );
            //Damian's Sword
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"), //item to derive from
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Damian's Sword", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Normal kid amr", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("assets/People/robin/swordthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("assets/People/robin/Sword.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        // Instance.FixColliders();
                    }
                }
            );
            //Harley's Hammer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Hammer"), //item to derive from
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Harley's Hammer", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Harley's hammer is mostly drawn as wooden and stuff, but for some reason the artists drew this as metallic. No clue honestly.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/OtherStuff/HammerThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assets/OtherStuff/HHammer.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        ///Instance.AddComponent<HammerHitter>();
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass *= 3f;
                        Instance.GetComponent<Rigidbody2D>().mass *= 3f;
                        Instance.FixColliders();
                    }
                }
            );
            //Joker's Pistol   
            ModAPI.Register(
                    new Modification()
                    {
                    OriginalItem = ModAPI.FindSpawnable("Flintlock Pistol"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Joker's Pistol", // Name.
                    DescriptionOverride = "I RULE THIS CITY - Joker",// Description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Joker/gunthumb.png", 7f),//Thumbnail
                    AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assets/People/Joker/gun.png", 2f);
					   Instance.FixColliders();
					   Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.3f, 0.05f);
					   var firearm = Instance.GetComponent<FirearmBehaviour>();
						Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new[]
						{
                            new Vector3(-0.2f, -0.05f)
                        };
                    }
                }
            );

            //Wing Ding Small Bird Version 
            ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"), // Searches the ingame catalog and returns with the inputted string if possible.
                        NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Robin's Wingdings", // Name.
                        DescriptionOverride = "Not sure if these are called batarangs or wingdings.\n Sharp in all directions.",// Description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"),//Category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/OtherStuff/RRangThumb.png"),//Thumbnail
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assets/OtherStuff/RRang.png");
                            Instance.FixColliders();
                            Instance.GetOrAddComponent<Throwable>();
                        }
                    }
            );

            //Wing Ding Color Absorbing Locomotion Limb Version 
            ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"), // Searches the ingame catalog and returns with the inputted string if possible.
                        NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Nightwings's Wingdings", // Name.
                        DescriptionOverride = "These ones are most likely called wingdings.\n Sharp in all directions.",// Description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"),//Category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/OtherStuff/NRangThumb.png"),//Thumbnail
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assets/OtherStuff/NRang.png");
                            Instance.FixColliders();
                            Instance.GetOrAddComponent<Throwable>().ImpactRequired = 0.4f; //You can change this number to change how hard it is to stab!
                        }
                    }
            );

            //Batarang
            ModAPI.Register( //hhhhhhhhhhhhhhhhhhhhhhhhhhh 'rang
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Batarang", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Deadly. Has several modes which can be changed via the context menu.\n Sharp in all directions.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("assets/People/Batman/BatarangThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assets/People/Batman/Batarang.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        Instance.FixColliders();
                        PhysicalBehaviour Phys = Instance.GetComponent<PhysicalBehaviour>();
                        Instance.GetOrAddComponent<Throwable>().ImpactRequired = 0.2f;
                        Phys.Properties.LodgeStrengthMultiplier *= 5f;
                        Phys.Properties.SharpForceThresholdMultiplier /= 3f;
                        Instance.GetOrAddComponent<BatarangPizza>();
                    }
                }
            );

            //Lex's Watch
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Lex's Watch",
                    DescriptionOverride = "Summons Lex's Mech. The arms contains two functions each. Interacting (activating) over the rocket launcher or sword deploying thing will perform the alternative function.",
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/OtherStuff/WatchThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assets/OtherStuff/LexWatch.png", 4f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        SpriteRenderer Glow = new GameObject("Glow", new Type[] //Some stupid stuff
                        {
                            typeof(SpriteRenderer)
                        }).GetComponent<SpriteRenderer>();
                        Glow.sprite = ModAPI.LoadSprite("Assets/OtherStuff/LexWatchGlow.png", 4f);
                        Glow.transform.SetParent(Instance.transform);
                        Glow.transform.localPosition = Vector2.zero;
                        Glow.transform.rotation = Instance.transform.rotation; //Prevents weird rotation
                        Glow.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Glow.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                        Glow.GetComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f);
                        Instance.FixColliders();
                        Instance.AddComponent<LexWatchBehaviour>();
                    }
                }
            );

            //Red Hood's Pistol  
            ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Pistol"), // Searches the ingame catalog and returns with the inputted string if possible.
                        NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Red Hood's Pistol", // Name.
                        DescriptionOverride = "Red Hood's go to shooty device",// Description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"),//Category
                        ThumbnailOverride = ResourceStorage.Sprite_RedHoodGunIcon,//Thumbnail
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_RedHoodGun;
                            Instance.FixColliders();
                        }
                    }
            );

            //DeadShot's Rifle
            ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"), // Searches the ingame catalog and returns with the inputted string if possible.
                        NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Deadshot's Sniper", // Name.
                        DescriptionOverride = "A killer gun for a killer killer.",// Description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"),//Category
                        ThumbnailOverride = ResourceStorage.Sprite_DeadShotGunIcon,//Thumbnail
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_DeadShotGun;
                            Instance.FixColliders();
                        }
                    }
            );

            //Hawkman's Mace
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Hawkman's Mace", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "An ancient relic.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("assets/People/Hawkman/mace thumbnail.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("assets/People/Hawkman/Mace.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        Instance.FixColliders();
                    }
                }
            );

            //Deathstroke's Sword
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"), //item to derive from
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Deathstroke's Sword", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "This has stabbed a ton of people, like a lot.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("assets/People/DeathStroke/Sword Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("assets/People/DeathStroke/Deathstroke_sword.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        Instance.FixColliders();
                    }
                }
            );

            //Kryptonite
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = DCppTag + "<color=blue>[Item]<color=white> Green Kryptonite", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A glowing green crystal, typically used to weaken Kryptonians.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("assets/OtherStuff/KryptoniteGThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("assets/OtherStuff/Kryptonite.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.GetComponent<SpriteRenderer>().color = new Color(0f, 0.15f, 0f);
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                        Instance.FixColliders();
                        Instance.AddComponent<KryptoniteBehaviour>();
                    }
                }
            );

            //Kryptonite 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = DCppTag + "<color=blue>[Item]<color=white> Pink Kryptonite", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Makes Superman romatically interested into men.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("assets/OtherStuff/KryptonitePThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("assets/OtherStuff/Kryptonite.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        Instance.GetComponent<SpriteRenderer>().color = new Color(0.15f, 0.05f, 0.05f);
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                        Instance.FixColliders();
                        Instance.AddComponent<KryptoniteBehaviour>().gay = true;
                    }
                }
            );

            //Kryptonite 3
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = DCppTag + "<color=blue>[Item]<color=white> Blue Kryptonite", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Even though this isn't cannonical, this gem turns regular humans into Kryptonians.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("assets/OtherStuff/KryptoniteBThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("assets/OtherStuff/Kryptonite.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        Instance.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0.15f);
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                        Instance.FixColliders();
                        Instance.AddComponent<KryptoniteBehaviour>().Good = true;
                    }
                }
            );

            //Kryptonite 4
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = DCppTag + "<color=blue>[Item]<color=white> Red Kryptonite", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Stronger version of green kryptonite. Causes irreversible damage.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("assets/OtherStuff/KryptoniteRThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("assets/OtherStuff/Kryptonite.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        Instance.GetComponent<SpriteRenderer>().color = new Color(0.3f, 0f, 0f);
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                        Instance.FixColliders();
                        Instance.AddComponent<KryptoniteBehaviour>().CheckMult = 2.5f;
                        Instance.GetComponent<KryptoniteBehaviour>().Color = new Color(1f, 0.65f, 0.65f, 1f);
                    }
                }
            );

            //Grapnel Gun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Grapnel Gun", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Interact with the base in order to fire the grapnel gun, then interact again to retract. Retracting can be stopped via activation, as well. Fully retracting will mean the hook will teleport to the gun, so yeah.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/OtherStuff/Grapnel_thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Assets/OtherStuff/GrapnelGun.png"); //get the SpriteRenderer and replace its sprite with a custom one          
                        Instance.FixColliders();
                        Instance.AddComponent<GrapnelGun>();
                    }
                }
            );

            //Nightwing's Escrima Sticks
            ModAPI.Register(
               new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Nightwing's Escrima Sticks", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Shocks the shit outta people.", //new item description
        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Nightwing/Escrima_thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            string Mode = "Staff";
            bool GrappleSticks = true;
            bool Grappling = false;
            DistanceJoint2D Wire = null;
            FixedJoint2D Hooknection = null;


            Instance.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_NightwingBat_1; //get the SpriteRenderer and replace its sprite with a custom one           
            Instance.AddComponent<ShockOnHit>();
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
            Instance.transform.eulerAngles += new Vector3(0, 0, 90);
            GameObject SecondInstance = GameObject.Instantiate(Instance);
            SecondInstance.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_NightwingBat_2; //get the SpriteRenderer and replace its sprite with a custom one   
            SecondInstance.AddComponent<ShockOnHit>();
            SecondInstance.transform.position = Instance.transform.position;
            SecondInstance.transform.position += new Vector3(ModAPI.PixelSize * 17, 0, 0);
            Hooknection = Instance.AddComponent<FixedJoint2D>();
            Hooknection.connectedBody = SecondInstance.GetComponent<Rigidbody2D>();
            SecondInstance.transform.SetParent(Instance.transform);

            Instance.AddComponent<UseEventTrigger>().Action = () =>
            {
                if (Mode == "Staff")
                {
                    if (Grappling && SecondInstance.GetComponent<WallStickDetector>() && SecondInstance.GetComponent<WallStickDetector>().HitSomething)
                    {
                        Instance.GetComponent<DistanceManager>().Reverse = true;
                        Grappling = false;
                    }
                    else if (!Grappling && SecondInstance.GetComponent<WallStickDetector>() && SecondInstance.GetComponent<WallStickDetector>().HitSomething)
                    {
                        Component.Destroy(SecondInstance.GetComponent<WallStickDetector>());
                        Component.Destroy(Instance.GetComponent<DistanceManager>());
                        if (SecondInstance.GetComponent<FixedJoint2D>())
                            Component.Destroy(SecondInstance.GetComponent<FixedJoint2D>());
                        Grappling = false;

                        {
                            Mode = "Staff";
                            if (Wire)
                            {
                                Component.Destroy(Wire);
                                Component.Destroy(Instance.GetComponent<EnergyWireBehaviour>());
                            }

                            if (Hooknection)
                                Component.Destroy(Hooknection);

                            SecondInstance.transform.SetParent(Instance.transform);
                            SecondInstance.transform.position = Instance.transform.position;
                            SecondInstance.transform.eulerAngles = Instance.transform.eulerAngles;
                            SecondInstance.transform.localPosition += new Vector3(0, -ModAPI.PixelSize * 17, 0);
                            Hooknection = Instance.AddComponent<FixedJoint2D>();
                            Hooknection.connectedBody = SecondInstance.GetComponent<Rigidbody2D>();
                        }
                    }
                }
            };


            Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("StaffMode", "Staff Mode", "Staff Mode", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    if(Mode != "Staff" && !Grappling)
                    {
                        Mode = "Staff";
                        if (Wire)
                        {
                            Component.Destroy(Wire);
                            Component.Destroy(Instance.GetComponent<EnergyWireBehaviour>());
                        }

                        if(Hooknection)
                            Component.Destroy(Hooknection);

                        SecondInstance.transform.SetParent(Instance.transform);
                        SecondInstance.transform.position = Instance.transform.position;
                        SecondInstance.transform.eulerAngles = Instance.transform.eulerAngles;
                        SecondInstance.transform.localPosition += new Vector3(0,-ModAPI.PixelSize * 17,0);
                        Hooknection = Instance.AddComponent<FixedJoint2D>();
                        Hooknection.connectedBody = SecondInstance.GetComponent<Rigidbody2D>();
                    }
                })
            }));
            Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("BillyMode", "Billy Bat Mode", "Billy Bat Mode", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    if(Mode != "Billy Bat" && !Grappling)
                    {
                        Mode = "Billy Bat";
                        if (Wire)
                        {
                            Component.Destroy(Wire);
                            Component.Destroy(Instance.GetComponent<EnergyWireBehaviour>());
                        }

                        if(Hooknection)
                            Component.Destroy(Hooknection);
                        SecondInstance.transform.SetParent(null);
                    }
                })
            }));
            SecondInstance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("StaffMode", "Staff Mode", "Staff Mode", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    if(Mode != "Staff" && !Grappling)
                    {
                        Mode = "Staff";
                        if (Wire)
                        {
                            Component.Destroy(Wire);
                            Component.Destroy(Instance.GetComponent<EnergyWireBehaviour>());
                        }

                        if(Hooknection)
                            Component.Destroy(Hooknection);

                        SecondInstance.transform.SetParent(Instance.transform);
                        SecondInstance.transform.position = Instance.transform.position;
                        SecondInstance.transform.eulerAngles = Instance.transform.eulerAngles;
                        SecondInstance.transform.localPosition += new Vector3(0,-ModAPI.PixelSize * 17,0);
                        Hooknection = Instance.AddComponent<FixedJoint2D>();
                        Hooknection.connectedBody = SecondInstance.GetComponent<Rigidbody2D>();
                    }
                })
            }));
            SecondInstance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("BillyMode", "Billy Bat Mode", "Billy Bat Mode", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    if(Mode != "Billy Bat" && !Grappling)
                    {
                        Mode = "Billy Bat";
                        if (Wire)
                        {
                            Component.Destroy(Wire);
                            Component.Destroy(Instance.GetComponent<EnergyWireBehaviour>());
                        }

                        if(Hooknection)
                            Component.Destroy(Hooknection);
                        SecondInstance.transform.SetParent(null);
                    }
                })
            }));

        }
    }
            );

            //Aquaman's Trident
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"), //item to derive from
                    NameOverride = DCppTag + "<color=green>[Weapon]<color=white>Aquaman's Trident", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A lethal weapon, it serves also as a symbol of the rulers of Atlantis.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("assets/People/Aquaman/Trident Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ResourceStorage.Sprite_AquamansTrident; //get the SpriteRenderer and replace its sprite with a custom one          
                        Instance.FixColliders();
                    }
                }
            );

            #endregion

            #region People

            // Black Canary
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Black Canary", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "I believe this is the part where our spunky heroines get stinking drunk. - Black Canary \n -Interact with head to blow up heads with a lethal scream.", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Black Canary/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();
                            if (person.Limbs[0]) //More efficient than searching through all limbs to find the head
                            {
                                HeadExploderPower.SetUpPower(person.Limbs[0], person, Instance);
                            }
                            person.SetBodyTextures(ResourceStorage.Skin_BlackCanary);
                    }
                }
            );
            //Joker
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Joker", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "I am not insane, i am woken. - Joker \n -Interact with head to make joker laugh", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Joker/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();
                            person.SetBodyTextures(ResourceStorage.Skin_Joker);
                            if (person.Limbs[0]) //More efficient than searching through all limbs to find the head
                            {
                                LaughPower.SetUpPower(person.Limbs[0], person, Instance);
                            }
                        }
                }
            );
            //Harley Quinn
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Harley Quinn", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I don't know about you, but I'm Harley working right now. Sorry.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Harley Quinn/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Harley);
                    }
                }
            );
            //Lex
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Lex Luthor", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Kyrptonite Fanboy.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Lex/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Lex);
                    }
                }
            );
            //Jim Gordon            
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Jim Gordon", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "If people take the law into their own hands, then there is no law. - Jim Gordon", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Jim Gordon/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(ResourceStorage.Skin_JimGordon);
                    }
                }
            );
            //Deadshot
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "DeadShot", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "Just get the job done. - Deadshot", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Deadshot/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(ResourceStorage.Skin_Deadshot);
                    }
                }
            );
           //Robin
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Robin (Tim Drake)", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "Okay, I’m impressed. Thumbs up. New Batmobile. - Robin (Tim Drake)", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/robin/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(ResourceStorage.Skin_Robin);
                            PPF.PowerPackFrameworkFunctions.CreateCape(person, ResourceStorage.Sprite_BatmanCape, 0.078f, ResourceStorage.Sprite_BatmanCapeBase);
                        }
                }
            );
            //Robin (Damian Wayne)
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Robin (Damian Wayne)", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "I'll kill you, clown boy! - Robin (Damian Wayne)", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Damian/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(ResourceStorage.Skin_Damian);
                            PPF.PowerPackFrameworkFunctions.CreateCape(person, ResourceStorage.Sprite_BatmanCape, 0.078f, ResourceStorage.Sprite_BatmanCapeBase);
                        }
                }
            );
           //Rex X
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Red X", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "Red X could be anyone. Anyone smart enough to find the suit, and dumb enough to take it for a joyride. - Former Red X", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/RedX/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(ResourceStorage.Skin_RedX);
                    }
                }
            );
            //Green Arrow
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Green Arrow", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "If you rely on your suit more than you rely on yourself… it’s going to get you killed. - Green Arrow", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Green Arrow/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(ResourceStorage.Skin_GreenArrow);
                    }
                }
            );
            //Superman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Superman", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "Man of Steel - Superman\n -Interact with the head to shoot a devastating laser beam.", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/superman/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();
                            person.SetBodyTextures(ResourceStorage.Skin_Superman);
                            /*if (person.Limbs[0]) //More efficient than searching through all limbs to find the head
                            {
                                 LaserEyePower.SetUpPower(person.Limbs[0], person, Instance);
                            }*/
                            if (person.Limbs[0])
                            {
                                LaserBlasterPower.SetUpPower(person.Limbs[0], person, Instance);
                            }
                            var las = person.Limbs[0].gameObject.GetComponent<LaserBlasterPower>();
                            las.LaserColor = new Color(1f, 0f, 0f, 1f);
                            las.Offset = new Vector2(0.05f, 0.04f);
                            las.UsingHead = true; ///This is an example if you want the constant laser to appear at the head instead.
                            GameObject Glow = new GameObject("GlowEffect", new Type[] { typeof(SpriteRenderer) });
                            Glow.transform.SetParent(person.Limbs[0].transform);
                            Glow.transform.position = person.Limbs[0].transform.position;
                            Glow.transform.localScale = new Vector2(((person.transform.lossyScale.x > 0f)? 1f : -1f) * person.transform.localScale.x, 1f * person.transform.localScale.y);
                            SpriteRenderer spr = Glow.GetComponent<SpriteRenderer>();
                            spr.material = ModAPI.FindMaterial("VeryBright");
                            spr.material.SetColor("_GlowColour", las.LaserColor);
                            spr.color = las.LaserColor;
                            spr.material.SetFloat("_GlowIntensity", 0.1f);
                            spr.sprite = ResourceStorage.Sprite_SupermanEyes;
                            spr.sortingOrder = person.Limbs[0].gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                            spr.sortingLayerID = person.Limbs[0].gameObject.GetComponent<SpriteRenderer>().sortingLayerID;
                            spr.enabled = false;
                            las.GlowSprite = spr;
                            las.ShootSfx = new AudioClip[]
                            {
                                ResourceStorage.Sound_SLaserConstant,
                                ResourceStorage.Sound_LaserOn,
                                ResourceStorage.Sound_SLaserOff
                            };
                            ContextMenuButton menuButton = new ContextMenuButton("togglefly", "Toggle Flying", "Toggle Flying", new UnityAction[1]
                            {
                                (UnityAction) (() =>
                                {
                                    if (person.Limbs[0].PhysicalBehaviour.IsWeightless)
                                    {
                                        foreach (var limb in person.Limbs)
                                        {
                                            limb.PhysicalBehaviour.MakeWeightful();
                                        }
                                    }
                                    else
                                    {
                                        foreach (var limb in person.Limbs)
                                        {
                                            limb.PhysicalBehaviour.MakeWeightless();
                                        }
                                    }
                                })
                            });
                            PPF.PowerPackFrameworkFunctions.CreateCape(person, ResourceStorage.Sprite_SupermanCape, 0.078f, ResourceStorage.Sprite_SupermanCapeBase);

                            foreach (LimbBehaviour Limb in person.Limbs) //I have like zero clue of what like a quarter of this does
                            {
                                Limb.BreakingThreshold *= 10f;
                                Limb.ImmuneToDamage = true;
                                Limb.ImpactPainMultiplier = 0f;
                                Limb.ShotDamageMultiplier = 0f;
                                Limb.Vitality *= 100f;
                                Limb.Health *= 100f;
                                Limb.InitialHealth *= 100f;
                                Limb.IsLethalToBreak = false;
                                Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                                Limb.PhysicalBehaviour.ConductOverride = true;
                                Limb.PhysicalBehaviour.EnergyWireResistance *= 100f;
                                Limb.PhysicalBehaviour.ForceNoCharge = true;
                                Limb.PhysicalBehaviour.SimulateTemperature = false;
                                Limb.PhysicalBehaviour.ReflectsLasers = true;
                                Limb.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                                Limb.CirculationBehaviour.ImmuneToDamage = true;
                                Limb.SkinMaterialHandler.intensityMultiplier = 0f;
                                Limb.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Incredible");
                                Limb.PhysicalBehaviour.ContextMenuOptions.Buttons.Add(menuButton);
                                Limb.gameObject.AddComponent<KyrptonGuy>();
                            }

                            PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Assets/People/Superman/skins/Bizzaro.png"), "1","Bizzaro, Superman's odd clone.");
                        }
                }
            );

            //SuperBoy
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Superboy", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "Lex Luthor's and Superman's Child. - Superboy\n -Interact with the head to shoot a devastating laser beam.", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Superboy/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();
                            person.SetBodyTextures(ResourceStorage.Skin_Superboy);
                            /*if (person.Limbs[0]) //More efficient than searching through all limbs to find the head
                            {
                                 LaserEyePower.SetUpPower(person.Limbs[0], person, Instance);
                            }*/
                            if (person.Limbs[0])
                            {
                                LaserBlasterPower.SetUpPower(person.Limbs[0], person, Instance);
                            }
                            var las = person.Limbs[0].gameObject.GetComponent<LaserBlasterPower>();
                            las.LaserColor = new Color(1f, 0f, 0f, 1f);
                            las.Offset = new Vector2(0.05f, 0.04f);
                            las.UsingHead = true; ///This is an example if you want the constant laser to appear at the head instead.
                            GameObject Glow = new GameObject("GlowEffect", new Type[] { typeof(SpriteRenderer) });
                            Glow.transform.SetParent(person.Limbs[0].transform);
                            Glow.transform.position = person.Limbs[0].transform.position;
                            Glow.transform.localScale = new Vector2(((person.transform.lossyScale.x > 0f)? 1f : -1f) * person.transform.localScale.x, 1f * person.transform.localScale.y);
                            SpriteRenderer spr = Glow.GetComponent<SpriteRenderer>();
                            spr.material = ModAPI.FindMaterial("VeryBright");
                            spr.material.SetColor("_GlowColour", las.LaserColor);
                            spr.color = las.LaserColor;
                            spr.material.SetFloat("_GlowIntensity", 0.1f);
                            spr.sprite = ResourceStorage.Sprite_SupermanEyes;
                            spr.sortingOrder = person.Limbs[0].gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                            spr.sortingLayerID = person.Limbs[0].gameObject.GetComponent<SpriteRenderer>().sortingLayerID;
                            spr.enabled = false;
                            las.GlowSprite = spr;
                            las.ShootSfx = new AudioClip[]
                            {
                                ResourceStorage.Sound_SLaserConstant,
                                ResourceStorage.Sound_LaserOn,
                                ResourceStorage.Sound_SLaserOff
                            };
                            ContextMenuButton menuButton = new ContextMenuButton("togglefly", "Toggle Flying", "Toggle Flying", new UnityAction[1]
                            {
                                (UnityAction) (() =>
                                {
                                    if (person.Limbs[0].PhysicalBehaviour.IsWeightless)
                                    {
                                        foreach (var limb in person.Limbs)
                                        {
                                            limb.PhysicalBehaviour.MakeWeightful();
                                        }
                                    }
                                    else
                                    {
                                        foreach (var limb in person.Limbs)
                                        {
                                            limb.PhysicalBehaviour.MakeWeightless();
                                        }
                                    }
                                })
                            });

                            foreach (LimbBehaviour Limb in person.Limbs) //I have like zero clue of what like a quarter of this does
                            {
                                Limb.BreakingThreshold *= 10f;
                                Limb.ImmuneToDamage = true;
                                Limb.ImpactPainMultiplier = 0f;
                                Limb.ShotDamageMultiplier = 0f;
                                Limb.Vitality *= 100f;
                                Limb.Health *= 100f;
                                Limb.InitialHealth *= 100f;
                                Limb.IsLethalToBreak = false;
                                Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                                Limb.PhysicalBehaviour.ConductOverride = true;
                                Limb.PhysicalBehaviour.EnergyWireResistance *= 100f;
                                Limb.PhysicalBehaviour.ForceNoCharge = true;
                                Limb.PhysicalBehaviour.SimulateTemperature = false;
                                Limb.PhysicalBehaviour.ReflectsLasers = true;
                                Limb.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                                Limb.CirculationBehaviour.ImmuneToDamage = true;
                                Limb.SkinMaterialHandler.intensityMultiplier = 0f;
                                Limb.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Incredible");
                                Limb.PhysicalBehaviour.ContextMenuOptions.Buttons.Add(menuButton);
                                Limb.gameObject.AddComponent<KyrptonGuy>(); //I just noticed I misspelled this
                            }

                            PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Assets/People/Superman/skins/Bizzaro.png"),"1", "Bizzaro, Superman's odd clone.");
                        }
                }
            );

            //Martian Manhunter
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Martian Manhunter", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "It's not easy being green. Can fly via the context menu.\n -Interact with the head to shoot a devastating laser beam.\n -Interact with hands to toggle disabling hands.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Martin MaleMurderer/martion.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Martian);
                        if (person.Limbs[0])
                        {
                            LaserBlasterPower.SetUpPower(person.Limbs[0], person, Instance);
                        }
                        var las = person.Limbs[0].gameObject.GetComponent<LaserBlasterPower>();
                        las.LaserColor = new Color(1f, 0f, 0f, 1f);
                        las.Offset = new Vector2(0.05f, 0.04f);
                        las.UsingHead = true; ///This is an example if you want the constant laser to appear at the head instead.
                        GameObject Glow = new GameObject("GlowEffect", new Type[] { typeof(SpriteRenderer) });
                        Glow.transform.SetParent(person.Limbs[0].transform);
                        Glow.transform.position = person.Limbs[0].transform.position;
                        Glow.transform.localScale = new Vector2(((person.transform.lossyScale.x > 0f) ? 1f : -1f) * person.transform.localScale.x, 1f * person.transform.localScale.y);
                        SpriteRenderer spr = Glow.GetComponent<SpriteRenderer>();
                        spr.material = ModAPI.FindMaterial("VeryBright");
                        spr.material.SetColor("_GlowColour", las.LaserColor);
                        spr.color = las.LaserColor;
                        spr.material.SetFloat("_GlowIntensity", 0.1f);
                        spr.sprite = ResourceStorage.Sprite_MarsEyes;
                        spr.sortingOrder = person.Limbs[0].gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        spr.sortingLayerID = person.Limbs[0].gameObject.GetComponent<SpriteRenderer>().sortingLayerID;
                        spr.enabled = false;
                        las.ShootSfx = new AudioClip[]
                        {
                            ResourceStorage.Sound_SLaserConstant,
                            ResourceStorage.Sound_LaserOn,
                            ResourceStorage.Sound_SLaserOff
                        };
                        DisablingHands.SetUpPower(person.Limbs[11], spr);
                        DisablingHands.SetUpPower(person.Limbs[13], spr);
                        ContextMenuButton menuButton = new ContextMenuButton("togglefly", "Toggle Flying", "Toggle Flying", new UnityAction[1]
                        {
                                (UnityAction) (() =>
                                {
                                    if (person.Limbs[0].PhysicalBehaviour.IsWeightless)
                                    {
                                        foreach (var limb in person.Limbs)
                                        {
                                            limb.PhysicalBehaviour.MakeWeightful();
                                        }
                                    }
                                    else
                                    {
                                        foreach (var limb in person.Limbs)
                                        {
                                            limb.PhysicalBehaviour.MakeWeightless();
                                        }
                                    }
                                })
                        });
                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ResourceStorage.Sprite_MartianCape, 0.078f, ResourceStorage.Sprite_MartianCapeBase);

                        foreach (LimbBehaviour Limb in person.Limbs) //I have like zero clue of what like a quarter of this does
                        {
                            Limb.BreakingThreshold *= 10f;
                            Limb.ImmuneToDamage = true;
                            Limb.ImpactPainMultiplier = 0f;
                            Limb.ShotDamageMultiplier = 0f;
                            Limb.Vitality *= 100f;
                            Limb.Health *= 100f;
                            Limb.InitialHealth *= 100f;
                            Limb.IsLethalToBreak = false;
                            Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                            Limb.PhysicalBehaviour.ConductOverride = true;
                            Limb.PhysicalBehaviour.EnergyWireResistance *= 100f;
                            Limb.PhysicalBehaviour.ForceNoCharge = true;
                            Limb.PhysicalBehaviour.SimulateTemperature = false;
                            Limb.PhysicalBehaviour.ReflectsLasers = true;
                            Limb.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                            Limb.CirculationBehaviour.ImmuneToDamage = true;
                            Limb.SkinMaterialHandler.intensityMultiplier = 0f;
                            Limb.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Incredible");
                            Limb.PhysicalBehaviour.ContextMenuOptions.Buttons.Add(menuButton);
                        }
                    }
                }
            );

            //Darkseid
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Darkseid", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "This guy needs a nerf.\n -Interact with head to shoot an omega beam.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Darkseid/thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        int X;
                        person.SetBodyTextures(ResourceStorage.Skin_Darkseid);
                        if (person.Limbs[0])
                        {
                            LaserBlasterPower.SetUpPower(person.Limbs[0], person, Instance);
                        }
                        var las = person.Limbs[0].gameObject.GetComponent<LaserBlasterPower>();
                        las.LaserColor = new Color(1f, 0f, 0f, 1f);
                        las.Offset = new Vector2(0.05f, 0.04f);
                        las.UsingHead = true; ///This is an example if you want the constant laser to appear at the head instead.
                        GameObject Glow = new GameObject("GlowEffect", new Type[] { typeof(SpriteRenderer) });
                        Glow.transform.SetParent(person.Limbs[0].transform);
                        Glow.transform.position = person.Limbs[0].transform.position;
                        Glow.transform.localScale = new Vector2(((person.transform.lossyScale.x > 0f) ? 1f : -1f) * person.transform.localScale.x, 1f * person.transform.localScale.y);
                        SpriteRenderer spr = Glow.GetComponent<SpriteRenderer>();
                        spr.material = ModAPI.FindMaterial("VeryBright");
                        spr.material.SetColor("_GlowColour", las.LaserColor);
                        spr.color = las.LaserColor;
                        spr.material.SetFloat("_GlowIntensity", 0.1f);
                        spr.sprite = ResourceStorage.Sprite_SupermanEyes;
                        spr.sortingOrder = person.Limbs[0].gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        spr.sortingLayerID = person.Limbs[0].gameObject.GetComponent<SpriteRenderer>().sortingLayerID;
                        spr.enabled = false;
                        las.GlowSprite = spr;
                        las.Tracking = true;
                        las.ShootSfx = new AudioClip[] //this literally does nothing, but I'm too lazy to make it so tracking mode doesn't check for audio
                        {
                            ResourceStorage.Sound_SLaserConstant,
                            ResourceStorage.Sound_LaserOn,
                            ResourceStorage.Sound_SLaserOff
                        };
                        foreach (LimbBehaviour Limb in person.Limbs)
                        {
                                Limb.BreakingThreshold *= 10f;
                                Limb.ImmuneToDamage = true;
                                Limb.ImpactPainMultiplier = 0f;
                                Limb.ShotDamageMultiplier = 0f;
                                Limb.Vitality *= 100f;
                                Limb.Health *= 100f;
                                Limb.FakeUprightForce *= 1.65f;
                                Limb.InitialHealth *= 100f;
                                Limb.IsLethalToBreak = false;
                                Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                                Limb.PhysicalBehaviour.ConductOverride = true;
                                Limb.PhysicalBehaviour.EnergyWireResistance *= 100f;
                                Limb.PhysicalBehaviour.ForceNoCharge = true;
                                Limb.PhysicalBehaviour.SimulateTemperature = false;
                                Limb.PhysicalBehaviour.ReflectsLasers = true;
                                Limb.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                                Limb.CirculationBehaviour.ImmuneToDamage = true;
                                Limb.SkinMaterialHandler.intensityMultiplier = 0f;
                                Limb.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Incredible");
                        }
                        Instance.transform.localScale = new Vector2(((Instance.transform.localScale.x <= 0)? -1.5f : 1.5f), 1.5f);
                    }
                }
            );

            //The Flash
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "The Flash", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "My name is Barry Allen and I'm the fastest man alive. - The Flash \n -Interact with chest to freeze time \n -Interact with hands to vibrate thier hands", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/flash/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();
                            person.SetBodyTextures(ResourceStorage.Skin_TheFlash);
                            if (person.Limbs[0]) //More efficient than searching through all limbs to find the head
                            {
                                //SpeedPower.SetUpPower(person.Limbs[0], person, Instance);
                                TimeStop.SetUpPower(person.Limbs[1], person, Instance);
                            }
                            //var speed = person.Limbs[0].gameObject.GetComponent<SpeedPower>();
                            //speed.TrailColor1 = new Color(1f, 0f, 0f, 1f);
                            //speed.TrailColor2 = new Color(1f, 1f, 0f, 1f);
                            SpeedsterVibrate.SetUpPower(person.Limbs[11], person, person.gameObject);
                            SpeedsterVibrate.SetUpPower(person.Limbs[13], person, person.gameObject);

                            PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Assets/People/Flash/skins/Flash_Unmasked_Blond.png"), "1","The Blond Variant of Unmasked Flash");
                            PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Assets/People/Flash/skins/Flash_Unmasked_Brown.png"), "2", "The Brown Variant of Unmasked Flash");
                        }
                }
            );
            //Kid Flash
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Kid Flash", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "You guys realize I can vibrate my molecules through solid matter, right? - Kid Flash \n -Interact with chest to freeze time \n -Interact with hands to vibrate thier hands", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Kid Flash/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();
                            person.SetBodyTextures(ResourceStorage.Skin_KidFlash);
                            if (person.Limbs[0]) //More efficient than searching through all limbs to find the head
                            {
                                if (person.Limbs[0]) //More efficient than searching through all limbs to find the head
                                {
                                    //SpeedPower.SetUpPower(person.Limbs[0], person, Instance);
                                    TimeStop.SetUpPower(person.Limbs[1], person, Instance);
                                }
                            }
                            //var speed = person.Limbs[0].gameObject.GetComponent<SpeedPower>();
                            //speed.TrailColor1 = new Color(1f, 0f, 0f, 1f);
                            //speed.TrailColor2 = new Color(1f, 1f, 0f, 1f);
                            SpeedsterVibrate.SetUpPower(person.Limbs[11], person, person.gameObject);
                            SpeedsterVibrate.SetUpPower(person.Limbs[13], person, person.gameObject);
                        }
                }
            );
            //Reverse Flash
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Reverse Flash", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "Barry Allen destroyed my future. It's time I destroyed his. - Reverse Flash \n \n -Interact with chest to freeze time \n -Interact with hands to vibrate thier hands", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/reverse flash/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(ResourceStorage.Skin_ReverseFlash);
                            if (person.Limbs[0]) //More efficient than searching through all limbs to find the head
                            {
                                //SpeedPower.SetUpPower(person.Limbs[0], person, Instance);
                                TimeStop.SetUpPower(person.Limbs[1], person, Instance);
                            }
                            //var speed = person.Limbs[0].gameObject.GetComponent<SpeedPower>();
                            //speed.TrailColor1 = new Color(1f, 1f, 0f, 1f);
                            //speed.TrailColor2 = new Color(1f, 0f, 0f, 1f);
                            SpeedsterVibrate.SetUpPower(person.Limbs[11], person, Instance);
                            SpeedsterVibrate.SetUpPower(person.Limbs[13], person, Instance);
                        }
                }
            );
            //Zoom
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Zoom", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "Look at your hero. This man is no god. He is nothing! - Zoom \n -Interact with chest to freeze time \n -Interact with hands to vibrate their hands", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/zoom/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(ResourceStorage.Skin_Zoom);
                            if (person.Limbs[0]) //More efficient than searching through all limbs to find the head
                            {
                                //SpeedPower.SetUpPower(person.Limbs[0], person, Instance);
                                TimeStop.SetUpPower(person.Limbs[1], person, Instance);
                            }
                            //var speed = person.Limbs[0].gameObject.GetComponent<SpeedPower>();
                            //speed.TrailColor1 = new Color(0f, 0, 1f, 1f);
                            //speed.TrailColor2 = new Color(0f, 255f, 229f, 1f);
                            SpeedsterVibrate.SetUpPower(person.Limbs[11], person, person.gameObject);
                            SpeedsterVibrate.SetUpPower(person.Limbs[13], person, person.gameObject);
                        }
                }
            );
            //Deathstroke
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                        NameOverride = DCppTag + "Deathstroke", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "You should've killed me. - Deathstroke", //new item description
                        CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("Assets/People/deathstroke/Thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {

                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            if (person.transform.localScale.x > 0)
                            {
                                person.SetBodyTextures(ResourceStorage.Skin_DeathStroke);
                            }
                            else
                            {
                                person.SetBodyTextures(ResourceStorage.Skin_DeathStrokeFlipped);
                            }
                            foreach (var limb in person.Limbs)
                            {
                                limb.Health *= 2;
                                limb.InitialHealth *= 2;
                                limb.ImpactPainMultiplier *= 0.5f;
                                limb.ShotDamageMultiplier *= 0.5f;
                            }
                        }
                }
            );
            //Billy Baxter/Shazam
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Billy Baxter/Shazam", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Hands, lighting with my hands, lighting with my hands! - Shazam \n -Interact with their head to toggle Shazam", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/shazam/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Shazam);
                        if (person.Limbs[0])
                        {
                            ShazamPower.SetUpPower(person.Limbs[0], ResourceStorage.Sprite_HeadExploderPowerIcon); //NEEDS THUMB!
                        }
                        var power = person.Limbs[0].gameObject.GetComponent<ShazamPower>();
                        //power.Name = "Egg Power"; //A way to change the name of the power for personalisation.
                        power.Original = ResourceStorage.Skin_Shazam;
                        power.Altered = ResourceStorage.Skin_ShazamSuit;
                        power.YellSound = ResourceStorage.Sound_ShazamYellingLikeAnIdiot;
                        Instance.transform.localScale = new Vector2((Instance.transform.localScale.x < 0) ? -1f : 1f, 1f);
                        ContextMenuButton menuButton = new ContextMenuButton("togglefly", "Toggle Flying", "Toggle Flying", new UnityAction[1]
                        {
                            (UnityAction) (() =>
                            {
                                if (power.IsShazam)
                                {
                                    if (person.Limbs[0].PhysicalBehaviour.IsWeightless)
                                    {
                                        foreach (var limb in person.Limbs)
                                        {
                                            limb.PhysicalBehaviour.MakeWeightful();
                                        }
                                    }
                                    else
                                    {
                                        foreach (var limb in person.Limbs)
                                        {
                                            limb.PhysicalBehaviour.MakeWeightless();
                                        }
                                    }
                                }
                            })
                        });
                        power.OnOriginal = new UnityAction(delegate ()
                        {
                            person.Consciousness = 1f;
                            foreach (LimbBehaviour Limb in person.Limbs)
                            {
                                Limb.ImmuneToDamage = false;
                                Limb.CirculationBehaviour.ImmuneToDamage = false;
                                Limb.SkinMaterialHandler.ClearAllDamage();
                                Limb.Health = 100f;
                                Limb.BreakingThreshold -= 10f;
                                if (Limb.HasJoint)
                                {
                                    Limb.Joint.breakForce -= 100f;
                                }
                                Limb.CirculationBehaviour.IsPump = true;
                                Limb.CirculationBehaviour.BloodFlow = 1f;
                                //Limb.PhysicalBehaviour.MakeWeightful();
                                Limb.CirculationBehaviour.ForceSetAllLiquid(1f);
                                Limb.PhysicalBehaviour.SimulateTemperature = true;
                                Limb.PhysicalBehaviour.BurningProgressionMultiplier = 1f;
                                Limb.PhysicalBehaviour.ContextMenuOptions.Buttons.Remove(menuButton);
                                Limb.Person.transform.localScale = new Vector2((Limb.Person.transform.localScale.x < 0)? -1f : 1f, 1f);
                            }
                        });
                        power.OnAlter = new UnityAction(delegate()
                        {
                            person.Consciousness = 1f;
                            foreach (LimbBehaviour Limb in person.Limbs)
                            {
                                Limb.ImmuneToDamage = true;
                                Limb.CirculationBehaviour.ImmuneToDamage = true;
                                Limb.SkinMaterialHandler.ClearAllDamage();
                                Limb.Health = 100f;
                                Limb.BreakingThreshold += 10f;
                                if (Limb.HasJoint)
                                {
                                    Limb.Joint.breakForce += 100f;
                                }
                                Limb.CirculationBehaviour.IsPump = true;
                                Limb.CirculationBehaviour.BloodFlow = 1f;
                                //Limb.PhysicalBehaviour.MakeWeightless();
                                Limb.CirculationBehaviour.ForceSetAllLiquid(1f);
                                Limb.PhysicalBehaviour.SimulateTemperature = false;
                                Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                                Limb.PhysicalBehaviour.ContextMenuOptions.Buttons.Add(menuButton);
                                Limb.Person.transform.localScale = new Vector2((Limb.Person.transform.localScale.x < 0) ? -1.25f : 1.25f, 1.25f);
                            }
                        });
                    }
                }
            );
            //Cyborg (Still needs some good sfx!)
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
                    NameOverride = DCppTag + "Cyborg", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Funny Quip - Cyborg \n -Interact with the lower front arm to shoot a devastating laser beam.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Cyborg/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Cyborg, ResourceStorage.Skin_CyborgFlesh, ResourceStorage.Skin_CyborgBone);

                        if (person.Limbs[11])
                        {
                            LaserBlasterPower.SetUpPower(person.Limbs[11], person, Instance);
                        }
                        var las = person.Limbs[11].gameObject.GetComponent<LaserBlasterPower>();
                        las.LaserColor = new Color(0f, 1f, 1f, 1f);
                        las.ShootSfx = new AudioClip[] 
                        {
                            ResourceStorage.Sound_LaserConstant,
                            ResourceStorage.Sound_LaserOn,
                            ResourceStorage.Sound_LaserOff
                        };
                        las.Behind = true;
                    }
                }
            );

            //Red Hood
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Red Hood", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "How long did you wait before replacing me, huh? A month? A week? I trusted you. - Jason Todd", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Red Hood/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_RedHood);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Assets/People/Red Hood/skins/Red_Hood_Unmasked.png"), "1", "The Unmasked Variant of Red Hood");
                    }
                }
            );

            //Batman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Batman", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "WHERE IS SHE?! - Batman", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Batman/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Batman);
                        person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Assets/People/Batman/batmanHead.png");
                        person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Assets/People/Batman/flesh.png"));
                        person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Assets/People/Batman/bone.png"));
                        //Cape function       ((((((((((((((((((((((((((The cape sprite)))))))))))))))))))))))))))((((CapeWidth))))(((((((((((((((((((((((((((((((The cape base sprite))))))))))))))))))))))))
                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ResourceStorage.Sprite_BatmanCape, 0.078f, ResourceStorage.Sprite_BatmanCapeBase);

                            //PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Assets/People/Batman/Batman/Batman_Unmasked.png"), "This is totally my halloween costume!");
                            //PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Assets/People/Batman/skins/Batman_Casual.png"), "I wonder who Batman is..");
                    }
                }
            );

            //Catwoman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Catwoman", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "No gun, Harv? Shame. This is gonna hurt. (meow) - Catwoman", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Cat Women/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_CatWomen);
                        person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Assets/People/Cat Women/catWomanHead.png");
                        person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Assets/People/Cat Women/flesh.png"));
                        person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Assets/People/Cat Women/bone.png"));
                    }
                }
            );

            //Batgirl
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Batgirl", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I'm not saying I'm Batgirl, I'm just saying that no one has seen the two of us together at the same time. - Barbara Gordon", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Batgirl/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Batgirl);
                        person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Assets/People/Batgirl/batWomanHead.png");
                        person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Assets/People/Batgirl/flesh.png"));
                        person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Assets/People/Batgirl/bone.png"));
                        PPF.PowerPackFrameworkFunctions.CreateCape(person, ResourceStorage.Sprite_BatgirlCape, 0.078f, ResourceStorage.Sprite_BatgirlCapeBase);
                    }
                }
            );

            //Bane
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Bane", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "IT WOULD BE EXTREMELY PAINFUL...FOR YOU. - Bane", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Bane/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Bane);
                        BaneBoost.SetUpPower(person.Limbs[0], person, person.gameObject,true);
                    }
                }
            );

            //Green Lantern
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Green Lantern", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "In brightest day, in blackest night, No evil shall escape my sight. - Hal Jordan", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Green Lantern/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_GreenLantern);
                        FistProjection.SetUpPower(person.Limbs[11], person, person.gameObject, new Color32(0, 65, 0, 255));
                        FistProjection.SetUpPower(person.Limbs[13], person, person.gameObject, new Color32(0, 65, 0, 255));
                    }
                }
            );

            //Sinestro
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Sinestro", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "In brightest day, in blackest night, beware your fears made into light. - Sinestro", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Sinestro/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Sinestro);
                        FistProjection.SetUpPower(person.Limbs[11], person, person.gameObject, new Color32(56, 53, 0, 255));
                        FistProjection.SetUpPower(person.Limbs[13], person, person.gameObject, new Color32(56, 53, 0, 255));
                    }
                }
            );

            //Aquaman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Aquaman", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Hurry Up, I’m Missing Happy Hour For This. - Aquaman", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Aquaman/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Aquaman);
                        foreach (var limb in person.Limbs)
                        {
                            limb.ExplodeLiquidAmount = 9999999999999;
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("WATER BREATHING SERUM"), 50);
                        }
                    }
                }
            );

            //Hawkman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Hawkman", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "We're soulmates. - Hawkman", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Hawkman/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Hawkman);
                        person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Assets/People/Hawkman/Hawkman Head.png");
                        person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Assets/People/Hawkman/Hawkman Head Flesh.png"));
                        person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Assets/People/Hawkman/HawKman Head Bone.png"));
                        Flying.SetUpPower(person, person.gameObject);
                        foreach (var limb in person.Limbs)
                        {
                            limb.Health *= 2;
                            limb.InitialHealth *= 2;
                            limb.ImpactPainMultiplier *= 0.5f;
                            limb.ShotDamageMultiplier *= 0.5f;
                        }
                    }
                }
            );

            //Nightwing
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Nightwing", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "It was good to see her laugh. Even if it was at me. - Nightwing", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Nightwing/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_Nightwing);
                    }
                }
            );

            //John Constantine
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "John Constantine", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "I'm a nasty piece of work, chief. Ask anybody. - John Constantine", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/John Constantine/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_JohnConstantine);
                        MagicPush.SetUpPower(person.Limbs[11], person, person.gameObject);
                        MagicPush.SetUpPower(person.Limbs[13], person, person.gameObject);
                    }
                }
            );

            //Wonder Woman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Wonder Woman", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "It is our sacred duty to defend the world and that is what I am going to do. - Wonder Woman", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Wonder Women/Thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ResourceStorage.Skin_WonderWoman);
                        Flying.SetUpPower(person, person.gameObject);
                        foreach (var limb in person.Limbs)
                        {
                            limb.Health *= 3;
                            limb.InitialHealth *= 3;
                            limb.ImpactPainMultiplier *= 0.3f;
                            limb.ShotDamageMultiplier *= 0.3f;
                        }
                    }
                }
            );

            //Wilson Woman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = DCppTag + "Wilson Woman", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Wilson is into drag? RuPaul gone be shook after this one.", //new item description
                    CategoryOverride = ModAPI.FindCategory("DC Power Pack"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Assets/People/Wilson/Wilson_Woman_thumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ModAPI.LoadTexture("Assets/People/Wilson/Wilson_Woman.png"));
                        person.Limbs[0].gameObject.AddComponent<RogVoice>();
                    }
                }
            );
            #endregion

            #region Vehicles
            //Boss 429
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Car"),
                NameOverride = DCppTag + "<color=yellow>[Vehicle]<color=white> The Batmobile",
                DescriptionOverride = "Batman's classic.",
                CategoryOverride = ModAPI.FindCategory("DC Power Pack"),
                ThumbnailOverride = ModAPI.LoadSprite("Assets/OtherStuff/BatCarThumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Component.Destroy(Instance.transform.GetChild(0).GetComponent<RandomCarTextureBehaviour>());
                    Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BatBody.png",5);
                    Instance.transform.GetChild(2).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Batmowheel.png",5);
                    Instance.transform.GetChild(1).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Batmowheel.png",5);
                    Instance.transform.GetChild(0).gameObject.GetComponent<CarBehaviour>().WheelJoints[1].anchor = new Vector2(2.668496f, -0.488606f);
                    Instance.transform.GetChild(0).gameObject.GetComponent<CarBehaviour>().WheelJoints[0].anchor = new Vector2(-2.176786f, -0.5219045f);
                    GameObject.Destroy(Instance.transform.GetChild(3).gameObject);
                    Instance.transform.GetChild(0).transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BatInsides.png",5);
                    GameObject.Destroy(Instance.transform.GetChild(6).gameObject);
                    GameObject.Destroy(Instance.transform.GetChild(5).gameObject);
                    GameObject.Destroy(Instance.transform.GetChild(4).gameObject);

                }

            }

            );

            #endregion

            #region Mech Builder
            PhysicalProperties prop = UnityEngine.Object.Instantiate<PhysicalProperties>(ModAPI.FindPhysicalProperties("Metal"));
            prop.Softness = 0.1f;
            GameObject Mech = new GameObject("Mech");
            GameObject Body = ModAPI.CreatePhysicalObject("Body", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Body.png"));
            GameObject UpperLegBack = ModAPI.CreatePhysicalObject("Leg", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Upperleg.png"));
            GameObject UpperLegFront = ModAPI.CreatePhysicalObject("Leg", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Upperleg.png"));
            GameObject LowerLegBack = ModAPI.CreatePhysicalObject("Leg", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Lowerleg.png"));
            GameObject LowerLegFront = ModAPI.CreatePhysicalObject("Leg", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Lowerleg.png"));
            GameObject FootBack = ModAPI.CreatePhysicalObject("Foot", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Foot.png"));
            GameObject FootFront = ModAPI.CreatePhysicalObject("Foot", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Foot.png"));
            GameObject UpperArmFront = ModAPI.CreatePhysicalObject("Arm", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Front_Upperarm.png"));
            GameObject UpperArmBack = ModAPI.CreatePhysicalObject("Arm", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Back_Upperarm.png"));
            GameObject LowerArmFront = ModAPI.CreatePhysicalObject("Arm", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Front_Lowerarm.png"));
            GameObject LowerArmBack = ModAPI.CreatePhysicalObject("Arm", ModAPI.LoadSprite("Assets/People/Lex/Mech/Mech_Back_Lowerarm.png"));
            Body.transform.SetParent(Mech.transform); //Setting parents so deleting one limb should delete the rest
            UpperLegBack.transform.SetParent(Mech.transform);
            UpperLegFront.transform.SetParent(Mech.transform);
            LowerLegBack.transform.SetParent(Mech.transform);
            LowerLegFront.transform.SetParent(Mech.transform);
            FootBack.transform.SetParent(Mech.transform);
            FootFront.transform.SetParent(Mech.transform);
            UpperArmBack.transform.SetParent(Mech.transform);
            UpperArmFront.transform.SetParent(Mech.transform);
            LowerArmBack.transform.SetParent(Mech.transform);
            LowerArmFront.transform.SetParent(Mech.transform);
            float CamsLexAdjustment = 0.5f;
            Body.transform.position = new Vector2(-0.1501447f + CamsLexAdjustment, 1.257502f); //Setting pos relative to Mech
            UpperLegBack.transform.position = new Vector2(0.3228553f, 0.01750195f);
            UpperLegFront.transform.position = new Vector2(0.3228553f, 0.01750195f);
            LowerLegBack.transform.position = new Vector2(0.6168554f, -0.9344978f);
            LowerLegFront.transform.position = new Vector2(0.6168554f, -0.9344978f);
            FootBack.transform.position = new Vector2(0.5638553f, -2.032498f);
            FootFront.transform.position = new Vector2(0.5638553f, -2.032498f);
            UpperArmBack.transform.position = new Vector2(-0.6681447f + CamsLexAdjustment, 0.9585021f);
            UpperArmFront.transform.position = new Vector2(-0.6681447f + CamsLexAdjustment, 0.9585021f);
            LowerArmBack.transform.position = new Vector2(-0.5731447f + CamsLexAdjustment, -0.8384981f);
            LowerArmFront.transform.position = new Vector2(-0.7871208f + CamsLexAdjustment, -0.8384981f);
            Body.GetComponent<PhysicalBehaviour>().Properties = prop; //This is done since not doing this causes errors (and to stab)
            UpperLegBack.GetComponent<PhysicalBehaviour>().Properties = prop;
            UpperLegFront.GetComponent<PhysicalBehaviour>().Properties = prop;
            LowerLegBack.GetComponent<PhysicalBehaviour>().Properties = prop;
            LowerLegFront.GetComponent<PhysicalBehaviour>().Properties = prop;
            FootBack.GetComponent<PhysicalBehaviour>().Properties = prop;
            FootFront.GetComponent<PhysicalBehaviour>().Properties = prop;
            UpperArmFront.GetComponent<PhysicalBehaviour>().Properties = prop;
            UpperArmBack.GetComponent<PhysicalBehaviour>().Properties = prop;
            LowerArmFront.GetComponent<PhysicalBehaviour>().Properties = prop;
            LowerArmBack.GetComponent<PhysicalBehaviour>().Properties = prop;

            UpperLegBack.GetComponent<SpriteRenderer>().sortingOrder = -1; //Setting sorting order to change what order the limbs appear in
            UpperLegFront.GetComponent<SpriteRenderer>().sortingOrder = 2;
            LowerLegBack.GetComponent<SpriteRenderer>().sortingOrder = -2;
            LowerLegFront.GetComponent<SpriteRenderer>().sortingOrder = 1;
            FootBack.GetComponent<SpriteRenderer>().sortingOrder = -3;
            UpperArmFront.GetComponent<SpriteRenderer>().sortingOrder = 6;
            UpperArmBack.GetComponent<SpriteRenderer>().sortingOrder = -5;
            LowerArmFront.GetComponent<SpriteRenderer>().sortingOrder = 5;
            LowerArmBack.GetComponent<SpriteRenderer>().sortingOrder = -4;
            HingeJoint2D joint1 = UpperLegBack.AddComponent<HingeJoint2D>(); //Adding joints
            joint1.connectedBody = Body.GetComponent<Rigidbody2D>();
            joint1.anchor = new Vector2(-0.3f, 0.3f);
            joint1.useLimits = true;
            joint1.autoConfigureConnectedAnchor = true;
            joint1.useMotor = true;
            joint1.motor = new JointMotor2D()
            {
                motorSpeed = 0f,
                maxMotorTorque = 40f
            };
            joint1.limits = new JointAngleLimits2D()
            {
                min = -140,
                max = 75
            };
            HingeJoint2D joint2 = UpperLegFront.AddComponent<HingeJoint2D>();
            joint2.connectedBody = Body.GetComponent<Rigidbody2D>();
            joint2.anchor = new Vector2(-0.3f, 0.3f);
            joint2.useLimits = true;
            joint2.autoConfigureConnectedAnchor = true;
            joint2.useMotor = true;
            joint2.motor = new JointMotor2D()
            {
                motorSpeed = 0f,
                maxMotorTorque = 40f
            };
            joint2.limits = new JointAngleLimits2D()
            {
                min = -140,
                max = 75
            };
            HingeJoint2D joint3 = LowerLegBack.AddComponent<HingeJoint2D>();
            joint3.connectedBody = UpperLegBack.GetComponent<Rigidbody2D>();
            joint3.anchor = new Vector2(0f, 0.4f);
            joint3.useLimits = true;
            joint3.autoConfigureConnectedAnchor = true;
            joint3.useMotor = true;
            joint3.motor = new JointMotor2D()
            {
                motorSpeed = 0f,
                maxMotorTorque = 30f
            };
            joint3.limits = new JointAngleLimits2D()
            {
                min = -5,
                max = 90
            };
            HingeJoint2D joint4 = LowerLegFront.AddComponent<HingeJoint2D>();
            joint4.connectedBody = UpperLegFront.GetComponent<Rigidbody2D>();
            joint4.anchor = new Vector2(0f, 0.4f);
            joint4.useLimits = true;
            joint4.autoConfigureConnectedAnchor = true;
            joint4.useMotor = true;
            joint4.motor = new JointMotor2D()
            {
                motorSpeed = 0f,
                maxMotorTorque = 30f
            };
            joint4.limits = new JointAngleLimits2D()
            {
                min = -5,
                max = 90
            };
            HingeJoint2D joint5 = FootBack.AddComponent<HingeJoint2D>();
            joint5.connectedBody = LowerLegBack.GetComponent<Rigidbody2D>();
            joint5.anchor = new Vector2(-0.2f, 0.3f);
            joint5.useLimits = true;
            joint5.autoConfigureConnectedAnchor = true;
            joint5.useMotor = true;
            joint5.motor = new JointMotor2D()
            {
                motorSpeed = 0f,
                maxMotorTorque = 25f
            };
            joint5.limits = new JointAngleLimits2D()
            {
                min = -35,
                max = 35
            };
            HingeJoint2D joint6 = FootFront.AddComponent<HingeJoint2D>();
            joint6.connectedBody = LowerLegFront.GetComponent<Rigidbody2D>();
            joint6.anchor = new Vector2(-0.2f, 0.3f);
            joint6.useLimits = true;
            joint6.autoConfigureConnectedAnchor = true;
            joint6.useMotor = true;
            joint6.motor = new JointMotor2D()
            {
                motorSpeed = 0f,
                maxMotorTorque = 25f
            };
            joint6.limits = new JointAngleLimits2D()
            {
                min = -35,
                max = 35
            };
            HingeJoint2D joint7 = UpperArmBack.AddComponent<HingeJoint2D>();
            joint7.connectedBody = Body.GetComponent<Rigidbody2D>();
            joint7.anchor = new Vector2(0f, 0.5f);
            joint7.useLimits = false;
            joint7.useMotor = true;
            joint7.motor = new JointMotor2D() 
            {
                motorSpeed = 0f,
                maxMotorTorque = 13f
            };
            joint7.autoConfigureConnectedAnchor = true;

            HingeJoint2D joint8 = UpperArmFront.AddComponent<HingeJoint2D>();
            joint8.connectedBody = Body.GetComponent<Rigidbody2D>();
            joint8.anchor = new Vector2(0f, 0.5f);
            joint8.useLimits = false;
            joint8.useMotor = true;
            joint8.motor = new JointMotor2D()
            {
                motorSpeed = 0f,
                maxMotorTorque = 13f
            };
            joint8.autoConfigureConnectedAnchor = true;

            HingeJoint2D joint9 = LowerArmBack.AddComponent<HingeJoint2D>();
            joint9.connectedBody = UpperArmBack.GetComponent<Rigidbody2D>();
            joint9.anchor = new Vector2(-0.1f, 0.9f);
            joint9.useLimits = true;
            joint9.autoConfigureConnectedAnchor = true;
            joint9.useMotor = true;
            joint9.motor = new JointMotor2D()
            {
                motorSpeed = 0f,
                maxMotorTorque = 7f
            };
            joint9.limits = new JointAngleLimits2D()
            {
                min = 45,
                max = -90
            };
            HingeJoint2D joint10 = LowerArmFront.AddComponent<HingeJoint2D>();
            joint10.connectedBody = UpperArmFront.GetComponent<Rigidbody2D>();
            joint10.anchor = new Vector2(0.1f, 0.9f);
            joint10.useLimits = true;
            joint10.autoConfigureConnectedAnchor = true;
            joint10.useMotor = true;
            joint10.motor = new JointMotor2D()
            {
                motorSpeed = 0f,
                maxMotorTorque = 7f
            };
            joint10.limits = new JointAngleLimits2D()
            {
                min = 45,
                max = -90
            };
            Mech.AddComponent<NoChildrenCollide>(); //Disables collision between the mech limbs
            EntireMechBehaviour persony = Mech.AddComponent<EntireMechBehaviour>();
            Body.AddComponent<MechBodyBehaviour>().Person = persony;
            FootBack.AddComponent<MechFootBehaviour>().Person = persony;
            FootFront.AddComponent<MechFootBehaviour>().Person = persony;
            LowerArmFront.AddComponent<MechGrabBehaviour>().Person = persony;
            LowerArmBack.AddComponent<MechLaserBehaviour>().Person = persony;
            Body.GetComponent<MechBodyBehaviour>().BackFoot = FootBack;
            Body.GetComponent<MechBodyBehaviour>().FrontFoot = FootFront;
            for (var i = 0; i < Mech.transform.childCount; i++)
            {
                Mech.transform.GetChild(i).gameObject.AddComponent<MechBehaviour>().Person = persony;
                persony.Limbs.Add(Mech.transform.GetChild(i).gameObject.GetComponent<MechBehaviour>());
                if (Mech.transform.GetChild(i).gameObject.name.Contains("Leg"))
                {
                    Mech.transform.GetChild(i).gameObject.GetComponent<MechBehaviour>().ForceMultiplier = 4f;
                }
            }
            Mech.SetActive(false);
            persony.Legs.Add(UpperLegFront.GetComponent<MechBehaviour>());
            persony.Legs.Add(UpperLegBack.GetComponent<MechBehaviour>());
            persony.Legs.Add(LowerLegFront.GetComponent<MechBehaviour>());
            persony.Legs.Add(LowerLegBack.GetComponent<MechBehaviour>());
            LexWatchBehaviour.Mech = Mech;
            #endregion
        }
    }
}


public class LogPosition : MonoBehaviour
{
    private void Update()
    {
        Debug.Log($"{gameObject.name} X: {transform.localPosition.x} Y: {transform.localPosition.y}");
    }
}

